function Supplementary_Code_2    
% Title: Dabrafenib PK
% Author: Marco Albrecht
% Last change: 04.10.2018

%% clean
clear global; close all; clc; 
format shortG
%% Parameter space
%ParameterName=["p.VcFS",  "p.VpFS", "p.QFS",   "p.kD",    "p.k1b",   "p.k1r",  "p.k1f",  "p.k2b",   "p.k2r",  "p.k2f",    "p.k3v",    "p.k3km",   "p.k4b",   "p.k4r",   "p.k4f",   "p.k4v",    "p.k4km",  "p.k6b",   "p.k6r",  "p.FU",      "p.KaK",     "p.VcK",     "p.k5b",     "p.k5r",    "p.k5f",     "p.ET",     "p.kt",     "p.kdegRNA"];
x=             [ 40.398    219.96    0.99494    4.2103     8.9205     13.281    2.5328   39.455     10.691    0.57139     0.1521       16.106     2.1393      21.695      2.3836    1.251       8.253     6.0073     1.9506   0.019459       1.9124        52.134      24.65       4.6502      0.94387       0.62912     0.6512       10.249];
lb=0.90*x;
ub=1.10*x;
ParameterName=["p.VcFS",  "p.VpFS", "p.QFS",   "p.kD",    "p.k1b",   "p.k1r",  "p.k1f",  "p.k2b",   "p.k2r",  "p.k2f",    "p.k3v",    "p.k3km",   "p.k4b",   "p.k4r",   "p.k4f",   "p.k4v",    "p.k4km",  "p.k6b",   "p.k6r",  "p.FU",      "p.KaK",     "p.VcK",     "p.k5b",     "p.k5r",    "p.k5f",     "p.ET",     "p.kt",     "p.kdegRNA"];
x=            [40.096     240.2     0.97531    4.5544    8.6349      13.457    2.7168   39.389     11.129   0.62106      0.14337      17.283     2.1562      20.155      2.2635    1.183       8.8695    5.7551     1.7941   0.018096       1.8301        51.05       23.982      5.0519      1.0268        0.64989      0.60637       10.107];
viewConstrain1=[lb-lb;x-lb;ub-lb];
viewConstrain2=[ParameterName;viewConstrain1(2,:)./viewConstrain1(3,:);x]';
display(["NAME","0-TO-1","VALUE";"","constrain","";"","","";viewConstrain2])% 

%% Just plot but activate plotting=1 in function multiobjective
tic
multiobjective(x);
toc

%% Evolutionary multi-objective obtimization
% rng default % For reproducibility
% options = optimoptions(@gamultiobj,'Display','iter','UseParallel',true,'PopulationSize', 20*length(ub) ,'PlotFcn',{@gaplotpareto,@gaplotscorediversity, @gaplotparetodistance, @gaplotrankhist, @gaplotspread }, 'OutputFcns', @outputfunction);
% FitnessFunction = @multiobjective; % Function handle to the fitness function
% numberOfVariables = length(ub); % Number of decision variables
% A = []; % No linear inequality constraints
% b = []; % No linear inequality constraints
% Aeq = []; % No linear equality constraints
% beq = []; % No linear equality constraints
% [x,Output]  = gamultiobj(FitnessFunction,numberOfVariables,A,b,Aeq,beq,lb,ub,options);

%% genetic algorithm
% if length(x)>10
% options = optimoptions('ga','Display','iter','UseParallel',true,'PopulationSize', 20*length(ub),'PlotFcn',{@gaplotbestf, @gaplotstopping,@gaplotbestindiv }, 'OutputFcns', @outputfunctionGA);
% else
% options = optimoptions('ga','Display','iter','UseParallel',true,                                'PlotFcn',{@gaplotbestf, @gaplotstopping,@gaplotbestindiv }, 'OutputFcns', @outputfunctionGA);
% end
% x = ga(@multiobjective,length(x),[],[],[],[],lb,ub,[],[],options);
% display(x)

%% Simulated annealing
% options = optimoptions(@simulannealbnd,'PlotFcn',{@saplotbestf,@saplottemperature,@saplotf,@saplotstopping});
% x = simulannealbnd(@multiobjective,x,lb,ub,options);
% round(x,2,'significant')

%% fmincon
% opts = optimoptions('fmincon','Algorithm','interior-point','Display','iter');
% x = fmincon(@multiobjective,x,[],[],[],[],lb,ub,[],opts)

%% Global fminCon search 
% opts = optimoptions('fmincon','Algorithm','interior-point');
% problem = createOptimProblem('fmincon','objective',@multiobjective,'x0',x,'lb',lb,'ub',ub,'options',opts);
% gs = GlobalSearch('Display','iter','PlotFcn',{@gsplotbestf, @gsplotfunccount}) ;
% [x,f] = run(gs,problem)
% f
%%
% 
% dlmwrite('x.txt',x)
% %dlmwrite('Output.txt',Output)
% attachment1='C:\Users\marco.albrecht\Documents\University_Luxembourg\Internships\Optimata\IsraelToymodel\DabraKeto\x.txt';
% %attachment2='C:\Users\marco.albrecht\Documents\University_Luxembourg\Internships\Optimata\IsraelToymodel\DabraKeto\Output.txt';
% 
% mail = 'marco.albrecht@posteo.de';
% setpref('Internet','E_mail',mail);
% setpref('Internet','SMTP_Username',mail);
% setpref('Internet','SMTP_Password','LetThePaperPass');
% props = java.lang.System.getProperties;
% props.setProperty('mail.smtp.auth','true');
% props.setProperty('mail.smtp.socketFactory.class', 'javax.net.ssl.SSLSocketFactory');
% props.setProperty('mail.smtp.socketFactory.port','465');
% sendmail(mail,'Hello From MATLAB! Code is done','Thanks for using sendmail.',{attachment1});
% % 
% 

% fprintf('The number of points on the Pareto front was: %d\n', size(x,1));
% fprintf('The number of generations was : %d\n', Output.generations);
% fprintf('The average distance measure of the solutions on the Pareto front was: %g\n', Output.averagedistance);
% fprintf('The spread measure of the Pareto front was: %g\n', Output.spread);
% % 
% system('shutdown -s')

end     
function objective = multiobjective(x)
%% Choose the modes
plotting=1;
PrognosisPlot=1;
Plotsave=0;

Peakweight=2;
multiobjectiveOpt = 0;

%profile on

try %goes until the end of the code, avoid code brake down due to rare error events by infeasible parmeter combinations
%% length of Parameter vector is sufficient to know the mode
p.EnzymeRegulOnly    = 1;
p.EnzymeRegulationOn = 1;
p.KetoconazoleOn     = 1;
objective            = zeros(1,7)        ;%Optimization output-vector
objectiveFail        = ones(1,7)*10e6   ;%search "try". 
%%

%% Parameter
p.VcFS     = x( 1);
p.VpFS     = x( 2);
p.QFS      = x( 3); 
p.kD       = x( 4);
p.k1b      = x( 5);
p.k1r      = x( 6);
p.k1f      = x( 7);
p.k2b      = x(08);
p.k2r      = x(09);
p.k2f      = x(10);
p.k3v      = x(11);
p.k3km     = x(12);
p.k4b      = x(13);
p.k4r      = x(14);
p.k4f      = x(15);
p.k4v      = x(16);
p.k4km     = x(17);
p.k6b      = x(18);
p.k6r      = x(19);
p.FU       = x(20);
p.KaK      = x(21); 
p.VcK      = x(22);
p.k5b      = x(23);
p.k5r      = x(24);
p.k5f      = x(25);
p.ET       = x(26);
p.kt       = x(27);
p.kdegRNA  = x(28);

p.EC     = 1;

%p.kdegE    = x(31);
%p.kp= (p.kdegRNA*p.kdegE*(p.k6r/p.k6b*p.EC)/(1 + p.k6r/p.k6b))/p.kt;
%% Always fixed parameter
p.tlag   =   0.482      ;% [h]   absorption lag-time Dabrafenib
p.Fgel   =   0.555     ;% [-]   relative bioavailability of gelatin capsule to HPMC capsule
p.Ka     =   1.88      ;% [L/h] absorption rate constant
p.CL0F   =  17.0       ;% [L/h] apparent initial clearence
p.CLindSS=  17.3       ;% [L/h] apparent inducible clearence at steady state
p.Dref   = 170.0       ;% [mg]  reference dose
p.y      =   0.927     ;% [-]   power of dependence of CLindSS on absorbed dose (LDOS X Fgel)
p.T50    =  67.3       ;% [h]   half-live of clearence induction
p.tlag   =   0.482     ;% [h]   absorption lag-time
p.VcF    =  70.3       ;% [L]   apparent volume of central compartment
p.VpF    = 174.0       ;% [L]   apparent volume of peripheral compartment
p.QF     =   3.3       ;% [L/h] apparent inter-compartmental clearence
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% Dabrafenib metabolites
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Regimen conditions %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
p.D             = 95      ;%[mg] Dabrafenib dose 
p.Dsolution     =  1      ;%     Dabrafenib given as solution (1) or HPMC (0)    
p.period        =  0      ;%     Periodic (1) or single (0) regimen         
p.DK            =  0      ;%[mg] Ketoconazole dose
p.DKt           =  0      ;%[h]  Ketoconazole dose. Time point of administration
p.tmax          = 250     ;%[h]  Simulation time
%% Simulation %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[t,c]=period(p,plotting)           ;%Numeric solver of the resulting time course
%% Compare to data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 1. Paper: Metabolism and Disposition of Oral Dabrafenib in Cancer Patients: 
%           Proposed Participation of Aryl Nitrogen in Carbon-Carbon Bond 
%           Cleavage via Decarboxylation following Enzymatic Oxidation
%% Dabrafenib
tD= [0.20       1.20     2.00   3.20    6.00    6.80  10.00    13.60  23.60 35.60  48.40];
Cm=[ 1273.99 1775.66  1501.57 851.16  282.13  180.60  130.83   62.47   9.44  3.56   1.80 ];
Cs =interpol(tD, t, c, 7);
xD0m=(sum((Cs-Cm).^2)+Peakweight*sum((Cs(1:2)-Cm(1:2)).^2))/length(Cm)/max(Cm);


if plotting==1
h1=figure(1);
x0=10;
y0=10;
width=30*25;
height=40*25;
set(gcf,'units','points','position',[x0,y0,width,height]);
set(gcf,'color','w');


s1=subplot(5,3,1);
plot(s1,t,c(:,7)*1000 ,'black',tD,Cm,'redo',tD,Cs,'blueo','Linewidth',2);
ylim(s1,[0 1.5*max(Cm)])
ylabel(s1,'Concentration [ng/mL]')
xlim(s1,[0 max(tD)])
xticks(s1,0:6:max(tD))
xlabel(s1,'Time [h]')
hLabel = get(gca,'XLabel');
set(hLabel, 'Position', get(hLabel, 'Position') + [21 0 0]); 
title(s1,'Dabrafenib D_{0c}  (95 mg, solution)')
s1.Box = 'off';
end
clearvars tD Cm Cs
%% Hydroxy-Dabrafenib 
tD= [  0.40   3.60   6.80   8.00  10.00  12.00 24.40 36.00 48.40];
Cm= [137.54 580.73 422.40 270.42 180.65 135.23 19.86  5.21  3.56];
Cs=interpol(tD, t, c, 12);
xDH=(sum((Cs-Cm).^2)+Peakweight*sum((Cs(1:2)-Cm(1:2)).^2))/length(Cm)/max(Cm);
if plotting==1
s2=subplot(5,3,2);
plot(s2,t,c(:,12)*1000,'black',tD,Cm,'redo',tD,Cs,'blueo','Linewidth',2)
ylim(s2,[0 1.5*max(Cm)])
ylabel(s2,'Concentration [ng/mL]')
xlim(s2,[0 max(tD)])
xlabel(s2,'Time [h]')
hLabel = get(gca,'XLabel');
set(hLabel, 'Position', get(hLabel, 'Position') + [21 0 0]); 
xticks(s2,0:6:max(tD))
title(s2,'Hydroxy-dabrafenib D_{Hc}  (95 mg, solution)')
s2.Box = 'off';
end
clearvars tD Cm Cs
%% Carbo-Dabrafenib 
tD= [0.40  0.80   1.20   7.20    9.20   12.40   17.20  23.60  36.80  48.40  72.00 96.40 120.40 170.00 172.40 192.40]; %
Cm= [1.39 24.51 169.10 967.20 1396.31 1099.18 1009.89 633.35 416.62 249.28 102.36 51.99  29.99  17.68  13.83   6.40]; %
Cs=interpol(tD, t, c, 13);
xDC=(sum((Cs-Cm).^2)+Peakweight*sum((Cs(4:6)-Cm(4:6)).^2))/length(Cm)/max(Cm);

if plotting==1
s3=subplot(5,3,4);

plot(s3,t/24,c(:,13)*1000,'black',tD/24,Cm,'redo',tD/24,Cs,'blueo','Linewidth',2)
ylim(s3,[0 1.5*max(Cm)])
ylabel(s3,'Concentration [ng/mL]')
xlim(s3,[0 max(tD)/24])
xlabel(s3,'Time [d]')
hLabel = get(gca,'XLabel');
set(hLabel, 'Position', get(hLabel, 'Position') + [3.5 0 0]); 
xticks(s3,0:1:max(tD)/24)
title(s3,'Carbo-dabrafenib D_{Cc}  (95 mg, solution)')
s3.Box = 'off';
end
clearvars tD Cm Cs
%% Desmethyl-dabrafenib
tD= [1.20 2.40 3.20 4.00  6.00  7.60 10.00 12.00 24.00 36.40 48.40 72.00 96.40 139.60 164.40 168.40]; %
Cm= [0.30 1.39 2.53 5.43 10.26 15.25 23.01 29.08 36.77 22.13 16.09  8.35  6.35   5.48   2.73   1.38]; %
Cs=interpol(tD, t, c, 14);
xDD=(sum((Cs-Cm).^2)+Peakweight*sum((Cs(8:10)-Cm(8:10)).^2))/length(Cm)/max(Cm);


if plotting==1
s4=subplot(5,3,5);
plot(s4,t/24,c(:,14)*1000,'black',tD/24,Cm,'redo',tD/24,Cs,'blueo','Linewidth',2)
ylim(s4,[0 1.5*max(Cm)])
ylabel(s4,'Concentration [ng/mL]')
xlim(s4,[0 max(tD)/24])
xlabel(s4,'Time [d]')
hLabel = get(gca,'XLabel');
set(hLabel, 'Position', get(hLabel, 'Position') + [3 0 0]); 
xticks(s4,0:1:max(tD)/24)
title(s4,'Desmethyl-dabrafenib D_{Dc}  (95 mg, solution)')
s4.Box = 'off';
end
clearvars tD Cm Cs
%% Enzyme CYP3A
if plotting==1
s5=subplot(5,3,[7 8]);
Y = c(:,[2 8 9 11 1])*100;  
h=area(s5,t,Y);
legend(s5,'E_B','E_{D0}','E_{DH}','E_{DD}','E_{f}','Location', 'Westoutside')
legend boxoff 
h(1).FaceColor = [35   97   196]/255;
h(2).FaceColor = [237  74  41]/255;
h(3).FaceColor = [237  198  42 ]/255;
h(4).FaceColor = [28   201  42]/255;
h(5).FaceColor = [124  168  239]/255;
xlim(s5,[0 24])
ylim(s5,[0 120])
ylabel(s5,'Relative [%]')
xticks(s5,[ 3 6 9 12 15 18 21 24])
xlabel(s5,'Time [h]')
hLabel = get(gca,'XLabel');
set(hLabel, 'Position', get(hLabel, 'Position') + [10 0 0]); 
title(s5,'CYP3A4 occupation (95 mg, solution)')
  
clearvars Y
end
%% Urine facies
p5= [2.65 9.12 15.00 26.18 50.59 74.12 97.65 121.76 145.29 168.82 192.65 216.18 240.29]; %
Cm5=[0.00 1.43 6.08  38.64 67.44 78.71 85.51  90.88  91.95  92.84  93.56  93.92  93.56]; %
% interpolate simulation results at the timepoints where we have data
IDX5=zeros(length(p5),8);
IDX5(:,5)=p5;
for i=1:length(p5)
IDX5(i,1:4)= [length(t(t<=p5(i))) length(t(t<=p5(i)))+1  t(length(t(t<=p5(i)))) t(length(t(t<=p5(i)))+1)]; %find the simulation point that is before and after a measured point (point position in the vector | point value)
IDX5(i,6)=100*c(IDX5(i,1),16)/(c(IDX5(i,1),7)+c(IDX5(i,1),12)+c(IDX5(i,1),13)+c(IDX5(i,1),14)+c(IDX5(i,1),15)+c(IDX5(i,1),16)); %U/(D0c DHc DDc M U)
IDX5(i,7)=100*c(IDX5(i,2),16)/(c(IDX5(i,2),7)+c(IDX5(i,2),12)+c(IDX5(i,2),13)+c(IDX5(i,2),14)+c(IDX5(i,2),15)+c(IDX5(i,2),16)); %U/(D0c DHc DDc M U)
end
IDX5(:,8)=IDX5(:,6)+(IDX5(:,7)-IDX5(:,6))/(IDX5(:,4)-IDX5(:,3)) *(IDX5(:,5)-IDX5(:,3)); %linear interpolation
Cs5=IDX5(:,8)';
% Finished interpolation
xFU=sum((Cs5-Cm5).^2)/length(Cm5)/max(Cm5);
if plotting==1
subplot(5,3,9);
plot(p5/24,Cm5,'redo',p5/24,Cs5,'blueo','Linewidth',2)
ylim([0 100])
ylabel('Relative [%]')
xlim([0 max(p5/24)])
xticks(0:1:max(p5/24))
xlabel('Time [d]')
hLabel = get(gca,'XLabel');
set(hLabel, 'Position', get(hLabel, 'Position') + [4 0 0]); 
title('Excretion  (95 mg, solution)')
Box = 'off';
% Make more place between subplots
% s1_pos = get(s1,'Position'); %get the position data for sublot1.
% s2_pos = get(s2,'Position'); %get the position data for sublot1.
% s3_pos = get(s3,'Position'); %get the position data for sublot1.
% s4_pos = get(s4,'Position'); %get the position data for sublot1.
% s5_pos = get(s5,'Position'); %get the position data for sublot1.
% s6_pos = get(s6,'Position'); %get the position data for sublot1.
% %                   'left'                   'bottom'                        'width'         'hight'
% set(s1,'Position',[s1_pos(1)                 s1_pos(2)+0.03                  s1_pos(3)       s1_pos(4)])
% set(s2,'Position',[s2_pos(1)+0.04            s2_pos(2)+0.03                  s2_pos(3)       s2_pos(4)])
% set(s3,'Position',[s3_pos(1)                 s3_pos(2)-0.04+0.03             s3_pos(3)       s3_pos(4)])
% set(s4,'Position',[s4_pos(1)+0.04            s4_pos(2)-0.04+0.03             s4_pos(3)       s4_pos(4)])
% set(s5,'Position',[s5_pos(1)+0.15            s5_pos(2)-0.08+0.03             s5_pos(3)-0.2   s5_pos(4)])
% set(s6,'Position',[s6_pos(1)                 s6_pos(2)-0.08+0.03             s6_pos(3)+0.04  s6_pos(4)])
end
clearvars  p5 Cm5 IDX5 Cs5 
%% Define objective function %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Profile = sum([2*xD0m xDH xDC xDD ]./[ 7.7817  8.9459  26.489  0.045389])/4; %Metabolite profiles
objective(1) = Profile ;
objective(2) = 0;% 0.10*min([median(x)/3.146  Profile])    ;%Keep parameter small but weight not more than 5% of profile fit
objective(3) = 0.1*xFU/0.1957                       ;%Excretion   
clearvars t c xD0m xDH xDC xDD xFU 
%% End of block
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


if p.KetoconazoleOn == 1
%% Ketocolazole 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Regimen conditions %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
p.D             =  0      ;%[mg] Dabrafenib dose 
p.Dsolution     =  0      ;%     Dabrafenib given as solution (1) or HPMC (0)    
p.period        =  0      ;%     Periodic (1) or single (0) regimen         
p.DK            = 100     ;%[mg] Ketoconazole dose
p.DKt           = 100*24  ;%[h]  Ketoconazole dose. Time point of administration
p.tmax          = 50      ;%[h]  Simulation time
%% Simulation %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[t2,c2]=period(p,plotting)         ;%Numeric solver of the resulting time course
%% Compare to data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2. Paper: Ketoconazole: A Review of its Therapeutic Efficacy in 
%           Superficial and Systemic Fungal Infections (1982)
%% Ketoconazole 100 mg tablet (fastened patients)
tK2 = [0 0.5 1 1.5 2 3 4 6 8 10 24 32 ] ;
CK2 = [0 0.664184892	1.18714261	1.0208095	0.788383335	0.546542185	0.312204129	0.101870573	0.03545488	0.020681366	0.002387942	0.001005899]*1000 ;% [mg/mL]
CsK2= interpol(tK2, t2, c2, 4);
Keto200=(sum([(CsK2-CK2).^2  Peakweight*(CsK2(2:4)-CK2(2:4)).^2] ))/(length(CK2))/max(CK2);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Regimen conditions %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
p.D             =  0      ;%[mg] Dabrafenib dose 
p.Dsolution     =  0      ;%     Dabrafenib given as solution (1) or HPMC (0)    
p.period        =  0      ;%     Periodic (1) or single (0) regimen         
p.DK            = 200     ;%[mg] Ketoconazole dose
p.DKt           = 100*24  ;%[h]  Ketoconazole dose. Time point of administration
p.tmax          = 50      ;%[h]  Simulation time
%% Simulation %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[t4,c4]=period(p,plotting)         ;%Numeric solver of the resulting time course
%% Compare to data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2. Paper: Ketoconazole: A Review of its Therapeutic Efficacy in 
%           Superficial and Systemic Fungal Infections (1982)
%% Ketoconazole 200 mg tablet (fastened patients)
tK4 = [0 0.5 1 1.5 2 3 4 6 8 10 24 48 ] ;
CK4 = [0 1.906453063 3.060210777 2.80692053	2.312067004	1.535447452	1.185411919	0.594856632	0.202616181	0.097383691	0.024931012	0.003259119]*1000 ;
CsK4=interpol(tK4, t4, c4, 4);
Keto400=(sum([(CsK4-CK4).^2  Peakweight*(CsK4(1:3)-CK4(1:3)).^2]))/(length(CK4))/max(CK4);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Regimen conditions %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
p.D             =  0      ;%[mg] Dabrafenib dose 
p.Dsolution     =  0      ;%     Dabrafenib given as solution (1) or HPMC (0)    
p.period        =  0      ;%     Periodic (1) or single (0) regimen         
p.DK            = 400     ;%[mg] Ketoconazole dose
p.DKt           = 100*24  ;%[h]  Ketoconazole dose. Time point of administration
p.tmax          = 50      ;%[h]  Simulation time
%% Simulation %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[t8,c8]=period(p,plotting)         ;%Numeric solver of the resulting time course
%% Compare to data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2. Paper: Ketoconazole: A Review of its Therapeutic Efficacy in 
%           Superficial and Systemic Fungal Infections (1982)
%% Ketoconazole 400 mg tablet (fastened patients)
tK8 = [0 0.5 1 1.5 2 3 4 6 8 10 24  32 48 ] ;
CK8 = [0 2.4156184	5.020202311	5.834214706	4.909966872	3.95770851	2.685248004	1.635379393	0.856747509	0.478701454	0.088742895	0.046351214	0.016369086]*1000 ; 
CsK8=interpol(tK8, t8, c8, 4);
Keto800=(sum([(CsK8-CK8).^2  Peakweight*(CsK8(4:6)-CK8(4:6)).^2] ))/(length(CK8))/max(CK8);
%% Plotting
if plotting==1
    
% h2=figure(2);
% x0=10;
% y0=10;
% width=40*25;
% height=20*25;
% set(gcf,'units','points','position',[x0,y0,width,height]);
% set(gcf,'color','w');

subplot(5,3,10)
hold on
plot( tK2,CK2,'mo',tK4,CK4,'ro',tK8,CK8,'go','Linewidth',2)
plot(t2,c2(:,4)*1000,'black',tK2,CsK2,'blueo','Linewidth',2);
plot(t4,c4(:,4)*1000,'black',tK4,CsK4,'blueo','Linewidth',2);
plot(t8,c8(:,4)*1000,'black',tK8,CsK8,'blueo','Linewidth',2);
ylim([0 1.2*max([CK2 CK4 CK8])])
xticks(0:3:24)
%yticks(0:5000:25000)
xlim([min([tK2 tK4 tK8]) 14])
ylabel('Concentration [ng/mL]')
xlabel('Time [h]')
hLabel = get(gca,'XLabel');
set(hLabel, 'Position', get(hLabel, 'Position') + [4 0 0]); 
title('Ketoconacole tablet (single dose)')
legend('100 mg','200 mg','400 mg')
legend boxoff 
hold off
end
clearvars tK8 CK8 tK8 CK8 CsK8 tK4 CK4 tK4 CK4 CsK4  tK2 CK2 tK2 CK2 CsK2
%% Define objective function %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
objective(4) = sum([Keto200  Keto400 2*Keto800]./[19.841       59.432       92.411])/3 ;%Ketoconazole profiles
clearvars Keto200  Keto400  Keto800
%% End of block
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%% Dabrafenib and Ketocolacole combined
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Regimen conditions %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
p.D             = 75      ;%[mg] Dabrafenib dose 
p.Dsolution     =  0      ;%     Dabrafenib given as solution (1) or HPMC (0)    
p.period        =  1      ;%     Periodic (1) or single (0) regimen         
p.DK            = 400     ;%[mg] Ketoconazole dose
p.DKt           = 19*24   ;%[h]  Ketoconazole dose. Time point of administration
p.tmax          = 22.5*24 ;%[h]  Simulation time
%% Simulation %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[t,c]=period(p,plotting)           ;%Numeric solver of the resulting time course
%% Compare to data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 3. Paper: Assessment of the drug interaction potential and single? and
%           repeat?dose pharmacokinetics of the BRAF inhibitor dabrafenib (2014)
% Patients received dabrafenib 75 mg twice daily from day 2 to day 17
% Ketoconazole dosed at 400mg daily on Days 19 through 22
% clinicaltrials.gov/ct2/show/NCT01340846?term=GSK2118436&rank=16&submit_fld_opt
% (Link opened 13.04.2018)
%% Two time spans of interest
t1= t>=17*24 & t<= 17*24+24;
t2= t>=21*24 & t<= 21*24+24;
%% Dabrafenib only at day 18                                                        
tD18  = [  0      0.5    1      1.5    2       3      4      6     8     10      12   ]; 
CD18  = [123.63 329.78 879.18 842.73 737.66  541.24 367.72 135.07 62.61   5.07   41.21];
CsD18 =interpol(tD18 ,(t(t1)-17*24), c(t1,:), 7);
xD18  =sum([(CsD18 - CD18).^2   Peakweight*(CsD18(1:4)-CD18(1:4)).^2])/(length(CD18 ))/max(CD18 );    
%% Dabrafenib and Ketoconazole; Dabrafenib profile at day 22                                            
tDk22 = [  0      0.5    1      1.5     2       3      4      6      8     10    12   ]; 
CDk22 = [ 77.87 219.92 599.98 925.13 1177.04  998.94 761.33 327.31 181.63 100.00 68.72];
CsDk22=interpol(tDk22,(t(t2)-21*24), c(t2,:), 7);
xDk22 =sum([(CsDk22-CDk22).^2  Peakweight*(CsDk22(4:6)-CDk22(4:6)).^2])/(length(CDk22))/max(CDk22);  
%% Dabrafenib and Ketoconazole; Ketoconazole profile at day 22  (Supplemental table S-3)                                            
tKd22 = [  0             1              2              4             8           12   ];
CKd22 = [ 69.6        4172.00        5123.40        3026.80        372.3         85.1 ];
CsKd22=interpol(tKd22,(t(t2)-21*24), c(t2,:), 4);
xKd22 =sum([(CsKd22-CKd22).^2  Peakweight*(CsKd22(3)-CKd22(3)).^2])/(length(CKd22))/max(CKd22);  
%% Metabolites
%Dabrafenib
a18D0=c(length(t(t<=17*24)):length(t(t<=17.5*24)), 7)*1000;
a22D0=c(length(t(t<=21*24)):length(t(t<=21.5*24)), 7)*1000;
% Hydroxy-dabrafenib
a18DH=c(length(t(t<=17*24)):length(t(t<=17.5*24)),12)*1000;
a22DH=c(length(t(t<=21*24)):length(t(t<=21.5*24)),12)*1000;
% Carboxy-dabrafenib
a18DC=c(length(t(t<=17*24)):length(t(t<=17.5*24)),13)*1000;
a22DC=c(length(t(t<=21*24)):length(t(t<=21.5*24)),13)*1000;
% Desmethyl-dabrafenib
a18DD=c(length(t(t<=17*24)):length(t(t<=17.5*24)),14)*1000;
a22DD=c(length(t(t<=21*24)):length(t(t<=21.5*24)),14)*1000;
xDK= ((max(a18D0)-966)^2 + (max(a22D0)-1285)^2 + (max(a18DH)-478)^2 + (max(a22DH)-607)^2 + (max(a18DC)-4242)^2 + (max(a22DC)-3347)^2 + (max(a18DD)-239)^2 + (max(a22DD)-411)^2)/(8*4242);
y = [966 max(a18D0) 1285 max(a22D0); 478 max(a18DH) 607 max(a22DH); 4242 max(a18DC) 3347 max(a22DC) ; 239 max(a18DD) 411 max(a22DD)];
%% Plot
if plotting==1

%%
subplot(5,3,[13 14 15])
hold on
plot(tD18,CD18 ,'mo', tDk22 ,CDk22,'ro' ,'Linewidth',2)
plot(t(t1)-17*24,1000*c(t1,7),'k'   ,tD18 ,CsD18 ,'bo','Linewidth',2);
plot(t(t2)-21*24,1000*c(t2,7),'k',tDk22,CsDk22,'bo','Linewidth',2);
legend('Day 18:     +0 mg ketoconazole','Day 22: +400 mg ketoconazole')
hold off
xticks(0:3:24)
xlabel('Time [h]')
hLabel = get(gca,'XLabel');
set(hLabel, 'Position', get(hLabel, 'Position') + [11 0 0]); 
title('Dabrafenib 75 mg BID (+Ketoconazole QD)')
ylabel('Concentration [ng/mL]')
legend boxoff 

subplot(5,3,11)
plot(tKd22,CKd22,'ro',t(t2)-21*24,1000*c(t2,4),'k',tKd22,CsKd22,'bo','Linewidth',2);
xticks(0:2:24)
xticklabels({'0','2','4','6','8','10','12','14','16','18','20','22','24'})
ylim([0 1.2*max(CKd22)])
xlim([min(tKd22)  max(tKd22)+2])
xticks(0:2:24)
ylabel('Concentration [ng/mL]')
xlabel('Time [d]')
hLabel = get(gca,'XLabel');
set(hLabel, 'Position', get(hLabel, 'Position') + [5 0 0]); 
%legend('Day 22:   +75 mg Dabrafenib')
%legend boxoff 
title('Ketoconazole 400 mg QD (+Dabrafenib 75 mg BID )')

subplot(5,3,12)
hold on
b = bar(y);
b(1).EdgeColor = 'red';
b(1).FaceColor = 'white';
b(2).EdgeColor = 'blue';
b(2).FaceColor = 'black';
b(3).EdgeColor = 'red';
b(3).FaceColor = 'white';
b(4).EdgeColor = 'blue';
b(4).FaceColor = 'black';
text(0.9,2000,'D_{0c}')
text(0.7,1700,'------------')
text(1.9,1500,'D_{Hc}')
text(1.7,1200,'------------')
text(2.9,4800,'D_{Cc}')
text(2.7,4500,'------------')
text(3.9,1100,'D_{Dc}')
text(3.7, 800,'------------')
xticks([0.8 1.2 1.8 2.2 2.8 3.2 3.8 4.2])
xticklabels({'18' '22' '18' '22' '18' '22' '18' '22' })
xlabel('Time [d]')
ylabel('Concentration [ng/mL]')
title('Dabrafenib peak levels')
legend('Data','Model','Location','Northwest')
legend boxoff 
hold off
if Plotsave==1
pos = get(h1,'Position');
set(h1,'PaperPositionMode','Auto','PaperUnits','points','PaperSize',[pos(3), pos(4)]);
export_fig('DabraKeto.pdf','-pdf');
end
end
%% Define objective function %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
objective(5) = sum([5*xD18 5*xDk22  xKd22  xDK]./[ 42.459   25.993  35.913  48.164])/4;%Ketoconazole and Dabrafenib profiles
clearvars tD18 CD18 CsD18 xD18  tDk22 CDk22 CsDk22 xDk22 tKd22 CKd22 CsKd22 xKd22
%% End of block
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
end % Ketoconazole loop

%if p.EnzymeRegulationOn ==1
%% Enzyme regulation
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Regimen conditions all %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
p.D             =  NaN    ;%[mg] Dabrafenib dose 
p.Dsolution     =  0      ;%     Dabrafenib given as solution (1) or HPMC (0)    
p.period        =  1      ;%     Periodic (1) or single (0) regimen         
p.DK            =  0      ;%[mg] Ketoconazole dose
p.DKt           =  0      ;%[h]  Ketoconazole dose. Time point of administration
p.tmax          = 19*24   ;%[h]  Simulation time
if PrognosisPlot==1
%Drug only until 22*24 h
p.tmax          = 8*7*24  ;%[h]  Simulation time
end
%ts              = p.tlag:0.5:(22+ p.tlag);
%% Compare to data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 4. Paper: Population pharmacokinetics of dabrafenib, a BRAF inhibitor: 
%           effect of dose, time, covariates, and relationship 
%           with its metabolites (2014)
%% Dabrafenib 150 mg: Simulation and data fit  %%%%%%%%%%%%%%%%%%%%%%%%%%%%
p.D             = 150      ;%[mg] Dabrafenib dose update 
[t15,ce15]=period(p,plotting)       ;%Numeric solver of the resulting time course
Donly150= sum((ce15(:,6)-ce15(:,7)).^2)/max(ce15(:,6))/length(ce15(:,6));

%EnzymeCap=(mean(ce15(ce15(:,24)>0.05,24))-0.76)^2 + (mean(ce15(ce15(:,25)>0.05,25))-0.32)^2;

% if p.EnzymeRegulationOn ==1
% d150=[0 93.5	81.4	77.1	72.9	69.8	66.5	63.6	60.7	58.2	55.7	53.5	52	50	48.9	47.5	46.6	45.2	44.8	43.7	43.1	42.3	41.9	41.4	41.2	40.6	40.4	40.2	39.8	39.2	38.8	38.6	38.6	38.1	38.3	38.1	38.1	38.1	38.1	38.1	37.9 repmat(38,1,20)];
% d150=d150(1:(22*2+1))      ;% Shorting data after extension (better balance during the fit)
% [pks15,locs15] = findpeaks(-ce15(:,7),t15);
% end
%% Dabrafenib 100 mg: Simulation and data fit  %%%%%%%%%%%%%%%%%%%%%%%%%%%%
p.D             = 100      ;%[mg] Dabrafenib dose update 
[t10,ce10]=period(p,plotting)       ;%Numeric solver of the resulting time course
Donly100= sum((ce10(:,6)-ce10(:,7)).^2)/max(ce10(:,6))/length(ce10(:,6));

% if p.EnzymeRegulationOn ==1
% if p.EnzymeRegulOnly ==1 
% d100=[0 65.3	62.8	62	61.3	59.7	58.2	57	55.5	54.1	52.4	51.6	49.7	48.7	47.7	46.6	45.4	45	44.3	43.9	43.1	42.7	42.7	42.3	41.9	41.4	41	41	40.6	40.6	39.8	40	40.4	39.8	40	39.6	39.6	39.6	39.4	39.4	39 repmat(39,1,20)]; %
% d100=d100(1:(22*2+1));
% [pks10,locs10] = findpeaks(-ce10(:,7),t10);
% end
% end
%% Dabrafenib  75 mg: Simulation and data fit  %%%%%%%%%%%%%%%%%%%%%%%%%%%%
p.D             =  75      ;%[mg] Dabrafenib dose update 
[t75,ce75]=period(p,plotting)       ;%Numeric solver of the resulting time course
Donly075= sum((ce75(:,6)-ce75(:,7)).^2)/max(ce75(:,6))/length(ce75(:,6));


% if p.EnzymeRegulationOn ==1
% if p.EnzymeRegulOnly ==1 
% d75=[0 50.4	50.8	51.8	52.2	52	51.6	50.4	49.7	48.7	47.9	47	46.2	45.2	44.4	43.5	42.9	42.7	41.9	41.9	41.4	41	40.4	40.4	39.8	40	39	39.6	38.8	38.6	38.8	38.6	38.8	38.6	38.5	38.1	38.1	38.3	38.1	37.9	38.1 repmat(38,1,20)];%
% d75=d75(1:(22*2+1));
% [pks75,locs75] = findpeaks(-ce75(:,7),t75);
% end
% end

%% Dabrafenib  50 mg: Simulation and data fit  %%%%%%%%%%%%%%%%%%%%%%%%%%%%
p.D             =  50      ;%[mg] Dabrafenib dose update 
[t50,ce50]=period(p,plotting)       ;%Numeric solver of the resulting time course
Donly050= sum((ce50(:,6)-ce50(:,7)).^2)/max(ce50(:,6))/length(ce50(:,6));

% if p.EnzymeRegulationOn ==1
% d50=[0  34.6	36.7	38.5	39.2	39.6	39.8	39.8	39.6	39.4	39	38.6	38.5	38.1	37.3	37.1	36.5	36.5	35.7	35.7	35.7	35.6	35.2	34.4	34.6	34.6	34.2	34.2	33.8	33.8	33.8 33.6	33.8	33.6	33.6	33.4	33.6	33.6	33.6	33.2	33.6 repmat(33.5,1,20)]; %
% d50=d50(1:(22*2+1));
% [pks50,locs50] = findpeaks(-ce50(:,7),t50);
% end

%% 
try
    
%% Dabrafenib only plot
if plotting==1
% h6=figure(6);
% x0=10;
% y0=10;
% width=20*25;
% height=30*25;
% set(gcf,'units','points','position',[x0,y0,width,height]);
% set(gcf,'color','w');
%% initial peak
subplot(5,3,3)
hold on
plot(432,1,'w')
plot(t15(t15<(12+p.tlag)) ,1000*ce15(t15<(12+p.tlag),7),'color',[231 231 231]./255,'Linewidth',10)
plot(t10(t10<(12+p.tlag)) ,1000*ce10(t10<(12+p.tlag),7),'color',[204 229 255]./255,'Linewidth',10)
plot(t75(t75<(12+p.tlag)) ,1000*ce75(t75<(12+p.tlag),7),'color',[255 204 204]./255,'Linewidth',10)
plot(t50(t50<(12+p.tlag)) ,1000*ce50(t50<(12+p.tlag),7),'color',[255 229 204]./255,'Linewidth',10)
%plot(432,1,'w')
plot(432,1,'w')
plot(t15(t15<(12+p.tlag)) ,1000*ce15(t15<(12+p.tlag),6),'k','Linewidth',3)
plot(t10(t10<(12+p.tlag)) ,1000*ce10(t10<(12+p.tlag),6),'--b','Linewidth',3)
plot(t75(t75<(12+p.tlag)) ,1000*ce75(t75<(12+p.tlag),6),'.r','MarkerSize',10)
plot(t50(t50<(12+p.tlag)) ,1000*ce50(t50<(12+p.tlag),6),'-.y','Linewidth',3)
ylabel('Concentration [ng/mL]')
xlabel('Time after first dose [h]')
legend({'Proposed model','150 mg BID','100 mg BID',' 75 mg BID',' 50 mg BID'},'FontSize',5,'location', 'northeast')
legend('boxoff')
hold off
ylim([0 1550])
xlim([0 12])

%% steady state 
subplot(5,3,6)
hold on
plot(432,1,'w','HandleVisibility','off')
plot(t15((t15>(18*24+p.tlag) & t15<(18.5*24+p.tlag))) ,1000*ce15(((t15>(18*24+p.tlag) & t15<(18.5*24+p.tlag))),7),'color',[231 231 231]./255,'Linewidth',10,'HandleVisibility','off')
plot(t10((t10>(18*24+p.tlag) & t10<(18.5*24+p.tlag))) ,1000*ce10(((t10>(18*24+p.tlag) & t10<(18.5*24+p.tlag))),7),'color',[204 229 255]./255,'Linewidth',10,'HandleVisibility','off')
plot(t75((t75>(18*24+p.tlag) & t75<(18.5*24+p.tlag))) ,1000*ce75(((t75>(18*24+p.tlag) & t75<(18.5*24+p.tlag))),7),'color',[255 204 204]./255,'Linewidth',10,'HandleVisibility','off')
plot(t50((t50>(18*24+p.tlag) & t50<(18.5*24+p.tlag))) ,1000*ce50(((t50>(18*24+p.tlag) & t50<(18.5*24+p.tlag))),7),'color',[255 229 204]./255,'Linewidth',10,'HandleVisibility','off')
plot(432,1,'w','HandleVisibility','off')
plot(432,1,'w')
plot((t15(t15>(18*24+p.tlag) & t15<(18.5*24+p.tlag))) ,1000*ce15((t15>(18*24+p.tlag) & t15<(18.5*24+p.tlag)),6),'k','Linewidth',3)
plot((t10(t10>(18*24+p.tlag) & t10<(18.5*24+p.tlag))) ,1000*ce10((t10>(18*24+p.tlag) & t10<(18.5*24+p.tlag)),6),'--b','Linewidth',3)
plot((t75(t75>(18*24+p.tlag) & t75<(18.5*24+p.tlag))) ,1000*ce75((t75>(18*24+p.tlag) & t75<(18.5*24+p.tlag)),6),'.r','MarkerSize',10)
plot((t50(t50>(18*24+p.tlag) & t50<(18.5*24+p.tlag))) ,1000*ce50((t50>(18*24+p.tlag) & t50<(18.5*24+p.tlag)),6),'-.y','Linewidth',3)
xticks([432 434 436 438 440 442 444 446])
xticklabels({'0' '2' '4' '6' '8' '10' '12' })
ylabel('Concentration [ng/mL]')
xlabel('Time after dose at day 18 [h]')
legend({'Published model','150 mg BID','100 mg BID',' 75 mg BID',' 50 mg BID'},'FontSize',5,'location', 'northeast')
legend('boxoff')
hold off
ylim([0 1550])
xlim([432 446])
hLabel = get(gca,'XLabel');
set(hLabel, 'Position', get(hLabel, 'Position') + [4.5 0 0]);
set(findall(gcf,'-property','FontSize'),'FontSize',8)
if Plotsave==1
pos = get(h6,'Position');
set(h6,'PaperPositionMode','Auto','PaperUnits','points','PaperSize',[pos(3), pos(4)]);
export_fig('DabraPill.pdf','-pdf');
end
end
% %% trough level plot
% if p.EnzymeRegulOnly ==0
%  % Residuals to align data
% ER=sum([ sum((d150(2:length(d150))'+ pks15*1000).^2)  sum((d50(2:length(d50))'+ pks50*1000).^2)]);
% % Standard deviation to align trough concentration shape
% ERSt=mean([ std(d150(2:length(d150))'+ pks15*1000)  std(d50(2:length(d50))'+ pks50*1000) ]);
% elseif p.EnzymeRegulOnly ==1
% % Residuals to align data
% ER=sum([ 2*sum((d150(2:length(d150))'+ pks15*1000).^2) ;  sum((d100(2:length(d100))'+ pks10*1000).^2) ;  sum((d75(2:length(d75))'+ pks75*1000).^2) ;  sum((d50(2:length(d50))'+ pks50*1000).^2)]);
% % Standard deviation to align trough concentration shape
% ERSt=mean([ std(d150(2:length(d150))'+ pks15*1000)  std(d100(2:length(d100))'+ pks10*1000)   std(d75(2:length(d75))'+ pks75*1000)   std(d50(2:length(d50))'+ pks50*1000) ]);
% end
catch
% ER=1000000000;
% ERSt=1000000000;
end
%% Plotting
if plotting==1
%figure(3)
% set(gcf,'color','w', 'Units', 'Normalized', 'OuterPosition', [0.5, 0.5, 0.4, 0.4]);
% subplot(2,2,1)
% plot(locs15/24, -pks15*1000,'k',ts,d150,'ko','Linewidth',2);
% title('150 mg Dabrafenib trough')
% ylim([0 1.5*max(d150)])
% if p.EnzymeRegulOnly ==1
% subplot(2,2,2)
% plot(locs10/24,-pks10*1000,'blue',ts,d100,'blue<','Linewidth',2);
% title('100 mg Dabrafenib trough')
% subplot(2,2,3)
% plot(locs75/24,-pks75*1000,'red',ts,d75,'red+','Linewidth',2);
% title('75 mg Dabrafenib trough')
% end
% subplot(2,2,4)
% plot(locs50/24,-pks50*1000,'y',ts,d50,'y>','Linewidth',2);
% title('50 mg Dabrafenib trough')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% 
h4=figure(4);
x0=10;
y0=10;
width=25*25;
height=40*25;
set(gcf,'units','points','position',[x0,y0,width,height])
set(gcf,'color','w')

d1=subplot(4,2,1);
Y = ce50(:,[2 8 9  11 1])*100;  
h=area(d1,t50,Y);
h(1).FaceColor = [35   97   196]/255;
h(2).FaceColor = [237  74  41]/255;
h(3).FaceColor = [237  198  42 ]/255;
h(4).FaceColor = [28   201  42]/255;
h(5).FaceColor = [124  168  239]/255;
xlim(d1,[0 48])
ylim(d1,[0 120])
ylabel(d1,'Relative [%]')
xticks(d1,[6 12 18 24 30 36 42 48])
xlabel(d1,'Time [h]')
title(d1,'CYP3A4 occupation ( 50 mg BID, HPMC)                                  ')
legend(d1,'E_B','E_{D0}','E_{DH}','E_{DD}','E_{f}','Location', 'Westoutside')
legend boxoff   
clearvars Y

d2=subplot(4,2,2);
Y = ce15(:,[2 8 9  11 1])*100;  
h=area(d2,t15,Y);
h(1).FaceColor = [35   97   196]/255;
h(2).FaceColor = [237  74  41]/255;
h(3).FaceColor = [237  198  42 ]/255;
h(4).FaceColor = [28   201  42]/255;
h(5).FaceColor = [124  168  239]/255;
xlim(d2,[0 48])
ylim(d2,[0 120])
ylabel(d2,'Relative [%]')
xticks(d2,[6 12 18 24 30 36 42 48])
xlabel(d2,'Time [h]')
title(d2,'CYP3A4 occupation (150 mg BID, HPMC)                                  ')
legend(d2,'E_B','E_{D0}','E_{DH}','E_{DD}','E_{f}','Location', 'Westoutside')
legend boxoff   
clearvars Y

subplot(4,2,[3 4]);
hold on
if p.EnzymeRegulationOn ==1
plot(t15/24, repmat(p.ET,length(t15),1),'k','Linewidth',2)
end
plot(t15/24, ce15(:,2),'color',[115, 115, 115]./255,'Linewidth',1.5)
plot(t75/24, ce75(:,2),'r','Linewidth',1.5)  
plot(t50/24, ce50(:,2),'color',[153, 51, 255]./255,'Linewidth',1.5)  
xlim([0 14])
title('CYP3A4 baseline use')
xlabel('Time [d]')
ylabel('Rel. to init. enzyme')
hLabel = get(gca,'XLabel');
set(hLabel, 'Position', get(hLabel, 'Position') + [6.5 0 0]);

subplot(4,2,[5 6]);
hold on
plot(t15/24, ce15(:,22),'color',[115, 115, 115]./255,'Linewidth',1.5)
plot(t75/24, ce75(:,22),'r','Linewidth',1.5)
plot(t50/24, ce50(:,22),'color',[153, 51, 255]./255,'Linewidth',1.5)
title('CYP3A4 mRNA level')
xlim([0 14])
ylim([0 max(ce15(:,22))])
xlabel('Time [d]')
ylabel('Rel. to init. enzyme')
legend('150 mg BID',' 75 mg BID',' 50 mg BID')
legend('boxoff')
hLabel = get(gca,'XLabel');
set(hLabel, 'Position', get(hLabel, 'Position') + [6.5 0 0]);

subplot(4,2,[7 8]);
hold on
plot(t15(ce15(:,23)>0.00001)/24, ce15(ce15(:,23)>0.00001,23),'color',[115, 115, 115]./255,'Linewidth',1.5)
plot(t75(ce75(:,23)>0.00001)/24, ce75(ce75(:,23)>0.00001,23),'r','Linewidth',1.5)
plot(t50(ce50(:,23)>0.00001)/24, ce50(ce50(:,23)>0.00001,23),'color',[153, 51, 255]./255,'Linewidth',1.5)
xlim([0 7])
title('CYP3A4 translation')
xlabel('Time [d]')
ylabel('log(rel. to init. enzyme)')
set(gca, 'YScale', 'log')
hLabel = get(gca,'XLabel');
set(hLabel, 'Position', get(hLabel, 'Position') + [3.2 0 0]);


if Plotsave==1
pos = get(h4,'Position');
set(h4,'PaperPositionMode','Auto','PaperUnits','points','PaperSize',[pos(3), pos(4)]);
export_fig('CYP3A4.pdf','-pdf');
end

%%
if PrognosisPlot==1
h7=figure(7);
x0=10;
y0=10;
width=15*25;
height=20*25;
set(gcf,'units','points','position',[x0,y0,width,height])
set(gcf,'color','w') 
%%%Max initial dose %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
p.D             =  150    ;%[mg] Dabrafenib dose 
p.Dsolution     =  0      ;%     Dabrafenib given as solution (1) or HPMC (0)    
p.period        =  0      ;%     Periodic (1) or single (0) regimen         
p.DK            =  0      ;%[mg] Ketoconazole dose
p.DKt           =  0      ;%[h]  Ketoconazole dose. Time point of administration
p.tmax          = 2*24   ;%[h]  Simulation time
[~,SingleDoseMaxce15]=period(p,plotting)       ;%Numeric solver of the resulting time course
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
s1=subplot(2,1,1);
hold on
plot(t15/24/7 ,1000*ce15(:,13)/max(SingleDoseMaxce15(:,13)*1000),'w','Linewidth',1)% dummy
plot(t15/24/7 ,1000*ce15(:,13)/max(SingleDoseMaxce15(:,13)*1000),'k','Linewidth',1)
plot(t10/24/7 ,1000*ce10(:,13)/max(SingleDoseMaxce15(:,13)*1000),'b','Linewidth',1)
plot(t75/24/7 ,1000*ce75(:,13)/max(SingleDoseMaxce15(:,13)*1000),'r','Linewidth',1) 
plot(t50/24/7 ,1000*ce50(:,13)/max(SingleDoseMaxce15(:,13)*1000),'y','Linewidth',1) 
line([4 4], [0 8],'Color','red')
legend(s1,'Dabrafenib (HPMC)','150 mg BID','100 mg BID',' 75 mg BID',' 50 mg BID')
legend boxoff 
ylabel('Relative to initial Cmax')
xlabel('Time [weeks]')
hLabel = get(gca,'XLabel');
set(hLabel, 'Position', get(hLabel, 'Position') + [2.5 0 0]); 
title('Prognosis for carbo-dabrafenib                                              ')
xlim(s1,[0 8])
ylim(s1,[0 10])

s2=subplot(2,1,2);
hold on
plot(t15/24/7 ,1000*ce15(:,14)/max(SingleDoseMaxce15(:,14)*1000),'w','Linewidth',1)% dummy
plot(t15/24/7 ,1000*ce15(:,14)/max(SingleDoseMaxce15(:,14)*1000),'k','Linewidth',1)
plot(t10/24/7 ,1000*ce10(:,14)/max(SingleDoseMaxce15(:,14)*1000),'b','Linewidth',1)
plot(t75/24/7 ,1000*ce75(:,14)/max(SingleDoseMaxce15(:,14)*1000),'r','Linewidth',1) 
plot(t50/24/7 ,1000*ce50(:,14)/max(SingleDoseMaxce15(:,14)*1000),'y','Linewidth',1) 
line([4 4], [0 8],'Color','red')
legend(s2,'Dabrafenib (HPMC)','150 mg BID','100 mg BID',' 75 mg BID',' 50 mg BID')
legend boxoff 
ylabel('Relative to initial Cmax')
xlabel('Time [weeks]')
hLabel = get(gca,'XLabel');
set(hLabel, 'Position', get(hLabel, 'Position') + [2.5 0 0]); 
title('Prognosis for desmethyl-dabrafenib                                           ')
xlim(s2,[0 8])
ylim(s2,[0 10])

if Plotsave==1
pos = get(h7,'Position');
set(h7,'PaperPositionMode','Auto','PaperUnits','points','PaperSize',[pos(3), pos(4)]);
export_fig('Prognosis.pdf','-pdf');
end
end
end
%% Define objective function %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
objective(6) = sum([4*Donly150 Donly100 Donly075 Donly050]./[0.0035079    0.0009349   0.00072165    0.0008465])/4;
%objective(7) = 3*EnzymeCap/0.13454;
%objective(7) = 2*sum([ER  ERSt]./[ 28261  4.5464]/2)  ;%Dabrafenib trough concentrations profiles
%% End of block
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%end


%% roboust run
catch
objective=objectiveFail;  %search "try". Filter rare parameter combinations with infeasible outcome
end
%% Single scalar as output if not multiobjective optimization.
if multiobjectiveOpt == 0

%sum(objective)
objective = sum(objective)/7.4333 ;%Always normalize to relate objectives better and if normalized to 1, one sees how much the fit improves or not improves
end
objective
%profile viewer




end
function [t2,c2]=period(p,plotting)
options = odeset('RelTol',1e-5,'AbsTol',1e-5);
if plotting==1
options = odeset('RelTol',1e-7,'AbsTol',1e-7);
end
warning('off','all')
% if Ketoconacole joins later to regimen
if   p.period==1
    for i = 1:floor((p.tmax+p.tlag)/12+1)
        %% 0 to p.tlag
        tspan=[((i-1)*12),((i-1)*12+p.tlag)];
        if i==1 %First dose
            c0=zeros(1,23);
            c0( 1)= (p.k6r/p.k6b*p.EC)/(1 + p.k6r/p.k6b); %analytic steady state solution w
%             p.E0=c0( 1);
            c0( 2)= p.EC-c0( 1);
%             if p.EnzymeRegulationOn == 1
%                 p.K = (p.kRNAdeg*p.Edeg2*p.Edeg1/p.kt)*(p.E0  +  (p.FB*p.Edeg1*p.E0^2)/( p.kt*p.Edeg2^2) ); %baseline production;
%             end
            %Solution makes oral compartment necessary
            if p.Dsolution==1
                c0(6) = p.D;
            end
            % once daily Ketoconacole after first application at dKt. if 'i' is odd, give drug
            if p.DKt <= tspan(1)
                if mod(i,2)==1
                    c0(3) =  p.DK;
                end
            end
            c2=c0;
            t2=0;
        else % following doses
            c0=[c2(end,1)  c2(end,2) c2(end,3) c2(end,4) c2(end,5) c2(end,6) c2(end,7) c2(end,8) c2(end,9) c2(end,10) c2(end,11) c2(end,12) c2(end,13) c2(end,14) c2(end,15) c2(end,16) c2(end,17) c2(end,18) c2(end,19) c2(end,20) c2(end,21) c2(end,22) c2(end,23) ];
            % Solution makes oral compartment necessary
            if p.Dsolution==1
                c0(6) = c2(end,6) + p.D;
            end
            % once daily Ketoconacole after first application at dKt. if 'i' is odd, give drug
            if p.DKt <= tspan(1)
                if mod(i,2)==1
                    c0(3) = c2(end,3)+ p.DK;
                end
            end
        end
        [t22,c22] = ode15s(@dabra,tspan,c0,options,p);
        t2=[t2(1:end-1)  ; t22];
        c2=[c2(1:end-1,:); c22];
        %% p.tlag to 12h
        tspan=[((i-1)*12+p.tlag),( i*12)];
        c0=[c2(end,1)  c2(end,2) c2(end,3) c2(end,4) c2(end,5) c2(end,6) c2(end,7) c2(end,8) c2(end,9) c2(end,10) c2(end,11) c2(end,12) c2(end,13) c2(end,14) c2(end,15) c2(end,16) c2(end,17) c2(end,18) c2(end,19) c2(end,20) c2(end,21) c2(end,22) c2(end,23)  ];
        [t22,c22] = ode15s(@dabra,tspan,c0,options,p);
        t2=[t2(1:end-1)  ; t22];
        c2=[c2(1:end-1,:); c22];
    end
else
    %% 0 to p.tlag
    tspan=[0 ,   p.tlag];
    c0=zeros(1,23);
    c0( 1)= (p.k6r/p.k6b*p.EC)/(1 + p.k6r/p.k6b); %analytic steady state solution with
    c0( 2)= p.EC-c0( 1);
%     if p.EnzymeRegulationOn == 1
%         p.K = (p.kRNAdeg*p.Edeg2*p.Edeg1/p.kt)*(p.E0  +  (p.FB*p.Edeg1*p.E0^2)/( p.kt*p.Edeg2^2) ); %baseline productionp
%     end
    c0(3)=p.DK;
    if p.Dsolution==1
        c0(6)=p.D;
    end
    c2=c0;
    t2=0;
    [t22,c22]   = ode15s(@dabra,tspan,c0,options,p);
    t2=[t2(1:end-1)  ; t22];
    c2=[c2(1:end-1,:); c22];
    %% p.tlag to 12h
    tspan=[p.tlag ,p.tmax];
    c0=[c2(end,1)  c2(end,2) c2(end,3) c2(end,4) c2(end,5) c2(end,6) c2(end,7) c2(end,8) c2(end,9) c2(end,10) c2(end,11) c2(end,12) c2(end,13) c2(end,14) c2(end,15) c2(end,16) c2(end,17) c2(end,18) c2(end,19) c2(end,20) c2(end,21) c2(end,22) c2(end,23) ];
    [t22,c22]   = ode15s(@dabra,tspan,c0,options,p);
    t2=[t2(1:end-1)  ; t22];
    c2=[c2(1:end-1,:); c22];
end
end
function [CsK]=interpol(tK, t2, c2,nu)
try
    IDXK=zeros(length(tK),8);
    IDXK(:,5)=tK;
    for i=1:length(tK)
        IDXK(i,1:4)= [length(t2(t2<=tK(i))) length(t2(t2<=tK(i)))+1  t2(length(t2(t2<=tK(i)))) t2(length(t2(t2<=tK(i)))+1)];
    end
    IDXK(:,6:7)=[c2(IDXK(:,1),nu) c2(IDXK(:,2),nu)];
    IDXK(:,8)=IDXK(:,6)+(IDXK(:,7)-IDXK(:,6))/(IDXK(:,4)-IDXK(:,3)) *(IDXK(:,5)-IDXK(:,3)); %linear interpolation
    CsK=1000*IDXK(:,8)' ;
catch
    CsK=100000; %punish
end
end
function dcdt=dabra(t,c,p)
%% Fixed Dabrafenib parameters
if p.Dsolution==1
    p.VcF    =   p.VcFS    ;% [L]   apparent volume of central compartment.
    p.VpF    =   p.VpFS    ;% [L]   apparent volume of peripheral compartment.
    p.QF     =   p.QFS     ;% [L/h] apparent inter-compartmental clearence.
else
    if           t < p.tlag
        Term   = 0;
    else
        if p.period ==1
            Term   = 0;
            nmax = floor(min([4*7*24 p.tmax])/12);%maximal num of cycles. Never more than 4*7*24
            n = min([floor((t-p.tlag)/12) nmax]);
            for  i = 1:(n+1)
                Term = Term + exp( -p.Ka*(t-(i-1)*12-p.tlag));
            end
        else
            Term = exp( -p.Ka *(t-p.tlag));
        end
    end
end
ClFind =  p.CLindSS*(p.D*p.Fgel/p.Dref)^p.y *(1-exp(-log(2)*t/p.T50));  % inducible clearence
ClF    =  p.CL0F + ClFind; % plus oral clearence

%% Reaction terms
% Michaelis Menten
CYP2C8  = 0; %p.k1v*c(07)/(p.k1km+c(07))                         ;% If product inhibition(p.k1v*c( 7)/p.k1km)/(1+(c( 7)/p.k1km)+(c( 7)/p.k1Im)) 
PHmm    = p.k3v*c(13)/(p.k3km+c(13))                             ;% DC->DD Lysosom/H30+ dependend
CYP2C19 = p.k4v*c(14)/(p.k4km+c(14))                             ;
% Enzyme occupation with dabrafenib metabolit
D0use   = p.k1b*c(1)*c( 7) - p.k1r*c( 8) - p.k1f*c( 8) ;   
DHuse   = p.k2b*c(1)*c(12) - p.k2r*c( 9) - p.k2f*c( 9) ;
%DCuse   = p.k3b*c(1)*c(13) - p.k3r*c(10)               ; %product inhibition sensitivity analysis says no 
DDuse   = p.k4b*c(1)*c(14) - p.k4r*c(11) - p.k4f*c(11) ;
Buse    = p.k6b*c(1)       - p.k6r*c(2)                ;
% Ketoconazole available
if p.KetoconazoleOn == 1
Keton   = p.k5b*c(1)*c(4)  - p.k5r*c(5)  - p.k5f*c(5)  ;
else
Keton  = 0;
end
%% CYP3A concentration and Baseline use %-p.kdegE*c(1) 
dcdt( 1) =  p.kt*c(22) -D0use -DHuse  -DDuse -Buse - Keton                                                                      ;%  d[E_f]dt    + (-min((c( 2)-p.ket),0))*p.kep -  c( 1)*p.ked            
dcdt( 2) =                                    Buse                                                                                                                             ;%  d[E_B]dt  baseline use of active enzyme   
%% Ketoconazole
if p.KetoconazoleOn == 1
dcdt( 3) =   - p.KaK*c(3)                                                                                                                                                       ;%  d[K_oral]   
dcdt( 4) =     p.KaK*c(3)/p.VcK                                                                                            - p.k5b*c(1)*c(4) + p.k5r*c(5)                       ;%  d[Kc]                                   
dcdt( 5) =                  Keton                                                                                                                                               ;%  d[E_K]dt    
else
dcdt( 3) = 0                                                                                                                                                                    ;%  d[K_oral]   
dcdt( 4) = 0                                                                                                                                                                    ;%  d[K_c]                                   
dcdt( 5) = 0                                                                                                                                                                    ;%  d[E_K]dt       
end
%% Dabrafenib solution radioactive (neclect p.FU because it is faster metabolized than excreted)
if p.Dsolution==1
dcdt( 6) =  - p.kD*c(6)                                                                                                                                                         ;%  d[D_0oral]dt  
dcdt( 7) =    p.kD*c(6)/p.VcF       - p.QF/p.VcF*(c(7)-c(18))  - CYP2C8                                                   - p.k1b*c(1)*c( 7)  + p.k1r*c( 8)                    ;%  d[D_0c]dt             
dcdt( 8) =                  D0use                                                                                                                                               ;%  d[E_D0]dt
%% Dabrafenib pill                  (neclect p.FU because it is faster metabolized than excreted)
else
dcdt( 6) =    p.Ka*p.D*Term/(p.VcF) - p.QF/p.VcF*(c(6)-c(18))  - ClF*c(6)/p.VcF                                                                                                 ;%  d[D_0c-paper]dt
dcdt( 7) =    p.Ka*p.D*Term/(p.VcF) - p.QF/p.VcF*(c(7)-c(18))  - CYP2C8                                                    - p.k1b*c(1)*c( 7)  + p.k1r*c( 8)                    ;%  d[D_0c-model]dt
dcdt( 8) =                  D0use                                                                                                                                               ;%  d[E_D0]dt
end
%% Dabrafenib Metabolites 
dcdt( 9) =                  DHuse                                                                                                                                               ;%  d[E_DH]dt
dcdt(10) =  0;               %DCuse                                                                                                                                             ;%  d[E_DC]dt    
dcdt(11) =                  DDuse                                                                                                                                               ;%  d[E_DD]dt
dcdt(12) = - p.FU*c(12)             - p.QF/p.VcF*(c(12)-c(19)) + CYP2C8                                                   - p.k2b*c(1)*c(12)  + p.k2r*c( 9)  + p.k1f*c( 8)      ;%  d[D_Hc]dt  
dcdt(13) = - p.FU*c(13)             - p.QF/p.VcF*(c(13)-c(20))            - PHmm                                                                             + p.k2f*c( 9)      ;%  d[D_Cc]dt   DC->DD Lysosom/H30+ dependend  - p.k3b*c(1)*c(13)  + p.k3r*c(10)
dcdt(14) = - p.FU*c(14)             - p.QF/p.VcF*(c(14)-c(21)) - CYP2C19  + PHmm                                          - p.k4b*c(1)*c(14)  + p.k4r*c(11)                     ;%  d[D_Dc]dt
dcdt(15) = - p.FU*c(15)                                        + CYP2C19                                                                                     + p.k4f*c(11)      ;%  d[M   ]dt
%% Excretion of dabrafenib
dcdt(16) =   p.FU*(c(12)+c(13)+c(14)+c(15))                                                                                                                                     ;% d[U]d excretion
%% peripheral compartment 
dcdt(17) =                            p.QF/p.VpF*(c( 6)-  c(17)) ;% d[D_0p]dt peripheral compartment of D0_oral or D0_c paper c( 6) 
dcdt(18) =                            p.QF/p.VpF*(c( 7) - c(18)) ;% d[D_0p]dt peripheral compartment of D0 c( 7)
dcdt(19) =                            p.QF/p.VpF*(c(12) - c(19)) ;% d[D_Hp]dt peripheral compartment of DH c(11)
dcdt(20) =                            p.QF/p.VpF*(c(13) - c(20)) ;% d[D_Cp]dt peripheral compartment of DC c(13)
dcdt(21) =                            p.QF/p.VpF*(c(14) - c(21)) ;% d[D_Dp]dt peripheral compartment of DD c(14)   
%% Enzyme regulation 
dcdt(22) =  max((p.ET-c( 2)),0) - p.kdegRNA*c(22)                     ;%  EmRNA      % +p.kp (-min((c( 2)-p.ET),0))
dcdt(23) =  p.kt*c(22) -c(23)                                         ;%  translation
%% Enzyme contribution
% CYP2C8sum  = CYP2C8  + p.k1b*c(1)*c( 7)  - p.k1r*c(8);
% CYP2C19sum = CYP2C19 + p.k4b*c(1)*c(14)  - p.k4r*c(11);
% if CYP2C8sum  >0
% dcdt(24) =  CYP2C8/CYP2C8sum -c(24);%contribution of CYP2C8  of Dabrafenib depletion 
% else
% dcdt(24)=0;
% end
% if CYP2C19sum  >0
% dcdt(25) =  CYP2C19/CYP2C19sum -c(25);%contribution of CYP2C19 of Desmethyl-Dabrafenib depletion  
% else
% dcdt(25)=0;
% end
%%
dcdt = dcdt';   % important! - transposes the solution vector
end     
function [state, options,optchanged] = outputfunction(options,state,flag)

%displays the function eval value at each iteration. You can change this
%disp(state.FunEval);
optchanged = false;
switch flag
   case 'init'
%         disp('Starting the algorithm');
    case {'iter','interrupt'}
%         disp('Iterating ...')
    if rem(state.Generation,10) == 0 % save all 5
    P=state.Population;
    S=state.Score;
    filename=join([num2str(state.FunEval) '.mat']);
    save(filename, 'P', 'S')
    end
    case 'done'
%         disp('Performing final task');
end
end
function [state, options,optchanged] = outputfunctionGA(options,state,flag)

%displays the function eval value at each iteration. You can change this
%disp(state.FunEval);
optchanged = false;
switch flag
   case 'init'
%         disp('Starting the algorithm');
    case {'iter','interrupt'}
%         disp('Iterating ...')
    if rem(state.Generation,10) == 0 % save all 5
    P=state.Population;
    filename=join([num2str(state.FunEval) '.mat']);
    save(filename, 'P')
    end
    case 'done'
    P=state.Population;
    filename=join([num2str(state.FunEval) '.mat']);
    save(filename, 'P')
end
end


