function Supplementary_Code_3
clc 
close all

%plotting=1; % if ==1 generation of plots

% Parameter of input    p.VcFS  p.VpFS p.QFS   p.kD    p.k1b   p.k1r   p.k1f   p.k1v     p.k1km  p.k2b   p.k2r  p.k2f    p.k3v    p.k3km   p.k4b   p.k4r   p.k4f p.k4v    p.k4km  p.k6b   p.k6r  p.FU      p.KaK   p.VcK   p.k5b   p.k5r   p.k5f    p.ET     p.kt     p.kdegRNA   
FIX                  = [37.337       153.73      0.97362       3.5109        9.326        13.41       1.7747  0.095248       119.65       53.606       10.455      0.45349      0.14058       18.556     1.8821       17.351       1.7869      0.96237       9.8721       5.7696       2.8094   0.021228         1.76       45.492       25.634       3.7024      0.94206      0.77119   0.089989       2.1354];
p.VcFS     = FIX( 1) ;
p.VpFS     = FIX( 2) ;
p.QFS      = FIX( 3) ; 
p.kD       = FIX( 4) ;
p.k1b      = FIX( 5) ;
p.k1r      = FIX( 6) ;
p.k1f      = FIX( 7) ;
p.k1v      = FIX( 8) ;
p.k1km     = FIX( 9) ;
p.k2b      = FIX(10) ;
p.k2r      = FIX(11) ;
p.k2f      = FIX(12) ;
p.k3b      = 0;
p.k3r      = 0;
p.k3v      = FIX(13) ;
p.k3km     = FIX(14) ;
p.k4b      = FIX(15) ;
p.k4r      = FIX(16) ;
p.k4f      = FIX(17) ;
p.k4v      = FIX(18) ;
p.k4km     = FIX(19) ;
p.k6b      = FIX(20) ;
p.k6r      = FIX(21) ;
p.FU       = FIX(22) ;
p.KaK      = FIX(23) ;
p.VcK      = FIX(24) ;
p.k5b      = FIX(25) ;
p.k5r      = FIX(26) ;
p.k5f      = FIX(27) ;
%p.EC       = 1       ;
% Add p.EC to equation c(15)
p.ET       =  0.55;
p.kt       = 0;
p.kdegRNA  = 0;
p.kdegE    = 0;

%% Always fixed Parameter
p.tlag    = 0.482      ;% [h]   absorption lag-time Dabrafenib
p.Fgel   =   0.555     ;% [-]   relative bioavailability of gelatin capsule to HPMC capsule
p.Ka     =   1.88      ;% [L/h] absorption rate constant
p.CL0F   =  17.0       ;% [L/h] apparent initial clearence
p.CLindSS=  17.3       ;% [L/h] apparent inducible clearence at steady state
p.Dref   = 170.0       ;% [mg]  reference dose
p.y      =   0.927     ;% [-]   power of dependence of CLindSS on absorbed dose (LDOS X Fgel)
p.T50    =  67.3       ;% [h]   half-live of clearence induction
p.tlag   =   0.482     ;% [h]   absorption lag-time
p.VcF    =  70.3       ;% [L]   apparent volume of central compartment
p.VpF    = 174.0       ;% [L]   apparent volume of peripheral compartment
p.QF     =   3.3       ;% [L/h] apparent inter-compartmental clearence

p.tlag   =   0.482     ;% [h]   absorption lag-time
%%
% 1. Paper: Metabolism and Disposition of Oral Dabrafenib in Cancer Patients: Proposed Participation of Aryl Nitrogen in Carbon-Carbon Bond Cleavage via Decarboxylation following Enzymatic Oxidations
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Anfangsbedingungen fuer die Simulation bzw. den Loeseraufruf
p.tmax=24*8;
%p.tmax=24*2;


p.D = 50  ;%Dose Dabrafenib
p.expD=[0 34.6	36.7	38.5	39.2	39.6	39.8	39.8	39.6	39.4	39	38.6	38.5	38.1	37.3	37.1	36.5	36.5	35.7	35.7	35.7	35.6	35.2	34.4	34.6	34.6	34.2	34.2	33.8	33.8	33.8 33.6	33.8	33.6	33.6	33.4	33.6	33.6	33.6	33.2	33.6]; %
[t4,c4,ECc4]=period(p);


p.D = 75  ;%Dose Dabrafenib
p.expD=[0 50.4	50.8	51.8	52.2	52	51.6	50.4	49.7	48.7	47.9	47	46.2	45.2	44.4	43.5	42.9	42.7	41.9	41.9	41.4	41	40.4	40.4	39.8	40	39	39.6	38.8	38.6	38.8	38.6	38.8	38.6	38.5	38.1	38.1	38.3	38.1	37.9	38.1];%
[t3,c3,ECc3]=period(p);

p.D = 100  ;%Dose Dabrafenib
p.expD=[0  65.3	62.8	62	61.3	59.7	58.2	57	55.5	54.1	52.4	51.6	49.7	48.7	47.7	46.6	45.4	45	44.3	43.9	43.1	42.7	42.7	42.3	41.9	41.4	41	41	40.6	40.6	39.8	40	40.4	39.8	40	39.6	39.6	39.6	39.4	39.4	39]; %
[t2,c2,ECc2]=period(p);
 
p.D = 150  ;%Dose Dabrafenib
p.expD=[0 93.5	81.4	77.1	72.9	69.8	66.5	63.6	60.7	58.2	55.7	53.5	52	50	48.9	47.5	46.6	45.2	44.8	43.7	43.1	42.3	41.9	41.4	41.2	40.6	40.4	40.2  	39.8	39.2	38.8   38.6	  38.6	38.1	38.3	38.1	38.1	38.1	38.1	38.1	37.9	];
[t1,c1,ECc1]=period(p);








% p150=[ 0.2529    0.6039    0.8553    1.0870    1.2750    1.4543    1.6100    1.7578    1.8844    2.0075    2.1149    2.1869    2.2844    2.3331    2.3999    2.4380    2.5084    2.5168    2.5729    2.5967    2.6361    2.6491    2.6712    2.6734    2.7063    2.7104    2.7163    2.7381    2.7751    2.7967   2.8034    2.7961    2.8293    2.8069    2.8185    2.8145    2.8116    2.8094    2.8078]
% p100=[ 0.0139    0.4199    0.5895    0.7316    0.8746    0.9962    1.0932    1.1889    1.2718    1.3598    1.4056    1.4955    1.5420    1.5874    1.6367  1.6907      1.7029    1.7321    1.7454    1.7815    1.7953    1.7878    1.8045    1.8214    1.8443    1.8615    1.8554    1.8745    1.8696    1.9140   1.8959    1.8686    1.9036    1.8882    1.9109    1.9081    1.9061    1.9169    1.9149]
% p75 =[ 0.1074    0.3096    0.4325    0.5414    0.6430    0.7307    0.8300    0.8989    0.9697    1.0249    1.0787    1.1237    1.1744    1.2134    1.2557   1.2822     1.2885    1.3253    1.3203    1.3424    1.3588    1.3859    1.3805    1.4089    1.3930    1.4450    1.4059    1.4483    1.4549    1.4397   1.4487    1.4350    1.4452    1.4493    1.4705    1.4679    1.4546    1.4654    1.4756]
% p50 =[ 0.0306    0.2116    0.2900    0.3791    0.4546    0.5184    0.5747    0.6272    0.6696    0.7135    0.7510    0.7694    0.7992    0.7994    0.8621  0.8938      0.8930    0.9352    0.9321    0.9302    0.9342    0.9546    0.9969    0.9808    0.9783    0.9991    0.9961    1.0171    1.0139    1.0117   1.0218    1.0080    1.0190    1.0176    1.0284    1.0152    1.0153    1.0146    1.0380]



save('EnzRegVar.mat','t1', 't2', 't3', 't4', 'c1', 'c2', 'c3', 'c4', 'ECc1', 'ECc2', 'ECc3', 'ECc4')

Matrix=[ECc1/150;ECc2/100;ECc3/75;ECc4/50];
display(Matrix*1000)

darkYellow=[228 212 95]./255;


h1=figure(1);



set(gcf,'color','w');
subplot(3,2,1)
hold on
plot(t4/24,c4(:,7)*1000,'color',darkYellow,'Linewidth',0.5)
plot(t3/24,c3(:,7)*1000,'r','Linewidth',0.5)
plot(t2/24,c2(:,7)*1000,'b','Linewidth',0.5)
plot(t1/24,c1(:,7)*1000,'k','Linewidth',0.5)
title('Dabrafenib')
ylabel('[ng/mL]')
xlim([0 6])

% subplot(3,2,2)
% hold on 
% plot(t4/24,smoothdata(c4(:,7),'rlowess',500),'y','Linewidth',0.5)
% plot(t3/24,smoothdata(c3(:,7),'rlowess',600),'r','Linewidth',0.5)
% plot(t2/24,smoothdata(c2(:,7),'rlowess',700),'b','Linewidth',0.5)
% plot(t1/24,smoothdata(c1(:,7),'rlowess',800),'k','Linewidth',0.5)
% title('Dabrafenib (smoothed)')
% xlim([0 6])

subplot(3,2,3)
hold on
plot(t4/24,c4(:,2),'color',darkYellow,'Linewidth',0.5)
plot(t3/24,c3(:,2),'r','Linewidth',0.5)
plot(t2/24,c2(:,2),'b','Linewidth',0.5)
plot(t1/24,c1(:,2),'k','Linewidth',0.5)
title('Baseline work')
ylabel('Fraction of total enzyme')
xlim([0 6])

subplot(3,2,4)
hold on
plot(t4/24,smoothdata(c4(:,2),'rlowess',500),'color',darkYellow,'Linewidth',0.5)
plot(t3/24,smoothdata(c3(:,2),'rlowess',600),'r','Linewidth',0.5)
plot(t2/24,smoothdata(c2(:,2),'rlowess',700),'b','Linewidth',0.5)
plot(t1/24,smoothdata(c1(:,2),'rlowess',800),'k','Linewidth',0.5)
title('Baseline work (smoothed)')
ylabel('Fraction of total enzyme')
xlim([0 6])

subplot(3,2,5)
hold on
plot(t4/24,c4(:,22),'color',darkYellow,'Linewidth',0.5)
plot(t3/24,c3(:,22),'r','Linewidth',0.5)
plot(t2/24,c2(:,22),'b','Linewidth',0.5)
plot(t1/24,c1(:,22),'k','Linewidth',0.5)
title('Baseline work below threshold (0.55)')
ylabel('Fraction of total enzyme')
xlim([0 6])
xlabel('Time [d]')

subplot(3,2,6)
hold on
plot((0:12:p.tmax)/24,ECc4,'color',darkYellow,'Linewidth',0.5)
plot((0:12:p.tmax)/24,ECc3,'r','Linewidth',0.5)
plot((0:12:p.tmax)/24,ECc2,'b','Linewidth',0.5)
plot((0:12:p.tmax)/24,ECc1,'k','Linewidth',0.5)
title('Total enzyme (step-wise estimated)')
xlim([0 6])
ylabel('Relative to one')
xlabel('Time [d]')
% hold on
% plot((0:12:p.tmax),ECc1./interpol((0:12:p.tmax), t1, smoothdata(c1(:,2),'rlowess',1000))
% title('normalized by smoothed baseline use')

%% Save Plot
pos = get(h1,'Position');
set(h1,'PaperPositionMode','Auto','PaperUnits','points','PaperSize',[pos(3), pos(4)]);
export_fig('EnzymeAdjust.pdf','-pdf');




end
function dcdt=dabra(t,c,p)
%% Fixed Dabrafenib parameters
% if p.Dsolution==1
%     p.VcF    =   p.VcFS    ;% [L]   apparent volume of central compartment.
%     p.VpF    =   p.VpFS    ;% [L]   apparent volume of peripheral compartment.
%     p.QF     =   p.QFS     ;% [L/h] apparent inter-compartmental clearence.
% else
    if           t < p.tlag
              Term = 0;
    else
%         if p.period ==1
              Term = 0;
              nmax = floor(p.tmax/12); % maximal num of cycles
                 n = min([floor((t-p.tlag)/12) nmax]);
            for  m = 1:(n+1)
              Term = Term + exp( -p.Ka*(t-(m-1)*12-p.tlag));
            end
%         else
%                    Term = exp( -p.Ka*(t-p.tlag));
%         end
    end
% end
ClFind =  p.CLindSS*(p.D*p.Fgel/p.Dref)^p.y *(1-exp(-log(2)*t/p.T50));  % inducible clearence
ClF    =  p.CL0F + ClFind; % plus oral clearence

%% Reaction terms
% Michaelis Menten
CYP2C8  = p.k1v*c( 7)/(p.k1km+c( 7))                             ;% If product inhibition(p.k1v*c( 7)/p.k1km)/(1+(c( 7)/p.k1km)+(c( 7)/p.k1Im)) 
PHmm    = p.k3v*c(13)/(p.k3km+c(13))                             ;% DC->DD Lysosom/H30+ dependend
CYP2C19 = p.k4v*c(14)/(p.k4km+c(14))                             ;
% Enzyme occupation with dabrafenib metabolit
D0use   = p.k1b*c(1)*c( 7) - p.k1r*c( 8) - p.k1f*c( 8) ;   
DHuse   = p.k2b*c(1)*c(12) - p.k2r*c( 9) - p.k2f*c( 9) ;
DCuse   = p.k3b*c(1)*c(13) - p.k3r*c(10)               ; %product inhibition
DDuse   = p.k4b*c(1)*c(14) - p.k4r*c(11) - p.k4f*c(11) ;
Buse    = p.k6b*c(1)       - p.k6r*c(2)                ;
% Ketoconazole available
% if p.KetoconazoleOn == 1
% Keton   = p.k5b*c(1)*c(4)  - p.k5r*c(5)  - p.k5f*c(5)  ;
% else
Keton  = 0;
% end
% Enzyme Regulation on
%if p.EnzymeRegulationOn == 1
%ERon  = p.kt*c(23) - p.Edeg1*c(1);                                    
%else
ERon  = 0;
%end
%% CYP3A concentration and Baseline use
dcdt( 1) =  ERon  -D0use -DHuse -DCuse -DDuse -Buse - Keton                                                                                                                     ;%  d[E_f]dt            
dcdt( 2) =                                     Buse                                                                                                                             ;%  d[E_B]dt  baseline use of active enzyme   
%% Ketoconazole
% if p.KetoconazoleOn == 1
% dcdt( 3) =   - p.KaK*c(3)                                                                                                                                                       ;%  d[K_oral]   
% dcdt( 4) =     p.KaK*c(3)/p.VcK                                                                                            - p.k5b*c(1)*c(4) + p.k5r*c(5)                       ;%  d[Kc]                                   
% dcdt( 5) =                  Keton                                                                                                                                               ;%  d[E_K]dt    
% else
dcdt( 3) = 0                                                                                                                                                                   ;%  d[K_oral]   
dcdt( 4) = 0                                                                                                                                                                    ;%  d[K_c]                                   
dcdt( 5) = 0                                                                                                                                                                    ;%  d[E_K]dt       
% end
%% Dabrafenib solution radioactive (neclect p.FU because it is faster metabolized than excreted)
%if p.Dsolution==1
% dcdt( 6) =  - p.kD*c(6)                                                                                                                                                         ;%  d[D_0oral]dt  
% dcdt( 7) =    p.kD*c(6)/p.VcF        - p.QF/p.VcF*(c(7)-c(18))  - CYP2C8                                                   - p.k1b*c(1)*c( 7)  + p.k1r*c( 8)                    ;%  d[D_0c]dt             
% dcdt( 8) =                  D0use                                                                                                                                               ;%  d[E_D0]dt
%% Dabrafenib pill                  (neclect p.FU because it is faster metabolized than excreted)
%else
dcdt( 6) =     p.Ka*p.D*Term/p.VcF - p.QF/p.VcF*(c(6)-c(18))  - ClF*c(6)/p.VcF                                                                                                 ;%  d[D_0c-paper]dt
dcdt( 7) =     p.Ka*p.D*Term/p.VcF - p.QF/p.VcF*(c(7)-c(18))  - CYP2C8                                                      - p.k1b*c(1)*c( 7)  + p.k1r*c( 8)                    ;%  d[D_0c-model]dt
dcdt( 8) =                  D0use                                                                                                                                              ;%  d[E_D0]dt
%end
%% Dabrafenib Metabolites 
dcdt( 9) =                  DHuse                                                                                                                                               ;%  d[E_DH]dt
dcdt(10) =                  DCuse                                                                                                                                               ;%  d[E_DC]dt    
dcdt(11) =                  DDuse                                                                                                                                               ;%  d[E_DD]dt
dcdt(12) = - p.FU*c(12)             - p.QF/p.VcF*(c(12)-c(19)) + CYP2C8                                                   - p.k2b*c(1)*c(12)  + p.k2r*c( 9)  + p.k1f*c( 8)      ;%  d[D_Hc]dt  
dcdt(13) = - p.FU*c(13)             - p.QF/p.VcF*(c(13)-c(20))            - PHmm                                          - p.k3b*c(1)*c(13)  + p.k3r*c(10)  + p.k2f*c( 9)      ;%  d[D_Cc]dt   DC->DD Lysosom/H30+ dependend
dcdt(14) = - p.FU*c(14)             - p.QF/p.VcF*(c(14)-c(21)) - CYP2C19  + PHmm                                          - p.k4b*c(1)*c(14)  + p.k4r*c(11)                     ;%  d[D_Dc]dt
dcdt(15) = - p.FU*c(15)                                        + CYP2C19                                                                                     + p.k4f*c(11)      ;%  d[M   ]dt
%% Excretion of dabrafenib
dcdt(16) =   p.FU*(c(12)+c(13)+c(14)+c(15))                                                                                                                                     ;% d[U]d excretion
%% peripheral compartment 
dcdt(17) =                            p.QF/p.VpF*(c( 6)-  c(17)) ;% d[D_0p]dt peripheral compartment of D0_oral or D0_c paper c( 6) 
dcdt(18) =                            p.QF/p.VpF*(c( 7) - c(18)) ;% d[D_0p]dt peripheral compartment of D0 c( 7)
dcdt(19) =                            p.QF/p.VpF*(c(12) - c(19)) ;% d[D_Hp]dt peripheral compartment of DH c(11)
dcdt(20) =                            p.QF/p.VpF*(c(13) - c(20)) ;% d[D_Cp]dt peripheral compartment of DC c(13)
dcdt(21) =                            p.QF/p.VpF*(c(14) - c(21)) ;% d[D_Dp]dt peripheral compartment of DD c(14)   
%% Enzyme regulation 
% if p.EnzymeRegulationOn == 1
% dcdt(22) =  (-min((c( 2)-p.ET),0)  + p.K )/(1+p.FB*c(25))- p.kRNAdeg*c(22);%  EmRNA
% dcdt(23) =         c(22)                                 -   p.Edeg2*c(23);%  Eprot
% dcdt(24)  =        c(23)                                 -   p.Edeg2*c(24);%  R1
% dcdt(25)  =        c(24)                                 -   p.Edeg2*c(25);%  R2 
% else
dcdt(22) =  -min((c( 2)-p.ET),0)-c(22)                                    ;%  EmRNA
dcdt(23) =  0                                                             ;%  Eprot
dcdt(24) =  0                                                             ;%  R1
dcdt(25) =  0                                                             ;%  R2  
% end
%%   
dcdt = dcdt';   % important! - transposes the solution vector
end     
function [CsK]=interpol(tK, t2, c2,nu)
try
    IDXK=zeros(length(tK),8);
    IDXK(:,5)=tK;
    for i=1:length(tK)
        IDXK(i,1:4)= [length(t2(t2<=tK(i))) length(t2(t2<=tK(i)))+1  t2(length(t2(t2<=tK(i)))) t2(length(t2(t2<=tK(i)))+1)];
    end
    IDXK(:,6:7)=[c2(IDXK(:,1),nu) c2(IDXK(:,2),nu)];
    IDXK(:,8)=IDXK(:,6)+(IDXK(:,7)-IDXK(:,6))/(IDXK(:,4)-IDXK(:,3)) *(IDXK(:,5)-IDXK(:,3)); %linear interpolation
    CsK=1000*IDXK(:,8)' ;
catch
    CsK=100000; %punish
end
end
function [t2,c2,ECc]=period(p)
p.ECc= zeros(1,floor((p.tmax+p.tlag)/12+1));
for i = 1:floor((p.tmax+p.tlag)/12+1)
    if i==1
    c2=0; %will be overwritten, just to give equation something at the beginning
    t2=0; %will be overwritten, just to give equation something at the beginning
    end
    p.it=i;
    ECadd = fminbnd(@(ECadd)IterateSim(ECadd,p,c2,t2),-1,1); % absolute Enzyme change between first and second number
    if i==1
    p.ECc(i)=ECadd;
    else
    p.ECc(i)=p.ECc(i-1)+ECadd;
    end
    [t2,c2]= calcSim(p,c2,t2,ECadd);
    clearvars EC
end





figure(2)
if p.D==150
    colorD = "k";
    colorD2 = "k";
    LW     = 0.5;
elseif p.D==100
    colorD = "b";
    colorD2 = "b";
     LW     =  0.5;
     
elseif p.D== 75
    colorD = "r";
    colorD2 = "r";
     LW     =  0.5;
elseif p.D== 50
    darkYellow=[228 212 95]./255;
    colorD = darkYellow;   
    colorD2 = 'Yellow';   
     LW     =  0.5;
end
subplot(3,5,[1 5])
hold on
timePl=0:12:(p.tmax+1);
plot(t2, c2(:,7)*1000,'color',colorD , 'LineWidth', LW) %Dabra
plot(timePl,p.expD(1:length(timePl)), strcat(colorD2, 'o'), 'LineWidth',  LW)
title('Dabrafenib')
subplot(3,5,[6 10])
hold on
plot(t2, c2(:,7)*1000,'color',colorD , 'LineWidth', LW) %Dabra
plot(timePl,p.expD(1:length(timePl)),strcat(colorD2, 'o'), 'LineWidth',   LW)
plot([12 12], [0  100],'c');
ylim([0 100])
title('Dabrafenib')
if p.D==150
subplot(3,5,[11 12])
Y = c2(:,[ 9 11 2 8 1]);
area(t2,Y)
title('CYP3A4 (Dabrafenib: 150)')
legend('DH-CY','DD-CY','B-CY','D0-Cy','Free CYP3A','Location', 'Westoutside')
ylim([0 2])
end
if p.D==100
subplot(3,5,13)
Y = c2(:,[ 9 11 2 8 1]);
area(t2,Y)
title('CYP3A4 (Dabrafenib: 100)')
ylim([0 2])
end
if p.D==75
subplot(3,5,14)
Y = c2(:,[ 9 11 2 8 1]);
area(t2,Y)
title('CYP3A4 (Dabrafenib:  75)')
ylim([0 2])
end
if p.D== 50
subplot(3,5,15)
Y = c2(:,[ 9 11 2 8 1]);
area(t2,Y)
title('CYP3A4 (Dabrafenib:  50)')
ylim([0 2])
end

%%%%%%%%%%%%%%%%%%%%%%
h1=figure(1);
x0=10;
y0=10;
width=22*25;
height=22*25;
set(gcf,'units','points','position',[x0,y0,width,height]);
set(gcf,'color','w');

subplot(3,2,2)
hold on
plot(t2/24, c2(:,7)*1000,'color',colorD , 'LineWidth', LW) %Dabra
plot(timePl/24,p.expD(1:length(timePl)),strcat(colorD2, 'o'), 'LineWidth',   LW)
plot([12 12], [0  100],'c');
ylabel('[ng/mL]')
ylim([0 100])
xlim([0 6])
title('Dabrafenib (trough concentration)')

ECc=p.ECc;
end
function x= IterateSim(ECadd,p,c2,t2)
    i=p.it;
   [~,c2]= calcSim(p,c2,t2,ECadd);
    x= (  c2(end,7)*1000  -   p.expD(i+1)  )^2;
end
function [t2,c2]= calcSim(p,c2,t2,ECadd)
options = odeset('RelTol',1e-7,'AbsTol',1e-7)  ;
i=p.it;
if i==1
    c0=zeros(1,25);
    c0( 1)= ((p.k6r/p.k6b)*ECadd)/(1 + p.k6r/p.k6b); %analytic steady state solution with  p.k6b*c(1)=p.k6r*c(2) and c(1)+c(2)=ECadd
    c0( 2)= ECadd-c0( 1);
    c2=c0;
    t2=0;
    tspan=[((i-1)*12),((i-1)*12+p.tlag)];
    [t22,c22] = ode15s(@dabra,tspan,c0,options,p);
    t2=[t2(1:end-1)  ; t22];
    c2=[c2(1:end-1,:); c22];
    tspan=[((i-1)*12+p.tlag),( i*12)];
    c0=[c2(end,1)  c2(end,2) c2(end,3) c2(end,4) c2(end,5)  c2(end,6) c2(end,7) c2(end,8) c2(end,9) c2(end,10) c2(end,11) c2(end,12) c2(end,13) c2(end,14) c2(end,15) c2(end,16) c2(end,17) c2(end,18) c2(end,19) c2(end,20) c2(end,21) c2(end,22) c2(end,23) c2(end,24) c2(end,25)];
    [t23,c23] = ode15s(@dabra,tspan,c0,options,p);
    t2=[t2(1:end-1)  ; t23];
    c2=[c2(1:end-1,:); c23];
else  %
    % previous simulation results plus enzyme induction
    c0=[c2(end,1) c2(end,2) c2(end,3) c2(end,4) c2(end,5)  c2(end,6) c2(end,7) c2(end,8) c2(end,9) c2(end,10) c2(end,11) c2(end,12) c2(end,13) c2(end,14) c2(end,15) c2(end,16) c2(end,17) c2(end,18) c2(end,19) c2(end,20) c2(end,21) c2(end,22) c2(end,23) c2(end,24) c2(end,25)];
    c0( 1)= c0( 1) +         ((p.k6r/p.k6b)*ECadd)/(1 + p.k6r/p.k6b); %analytic steady state solution with  p.k6b*c(1)=p.k6r*c(2) and c(1)+c(2)=ECadd
    c0( 2)= c0( 2) + ECadd  -((p.k6r/p.k6b)*ECadd)/(1 + p.k6r/p.k6b);
    
    %   if p.Dsolution==1
%        c0(6) = c2(end,6) + p.D;
%     end
    tspan=[((i-1)*12),((i-1)*12+p.tlag)];
    [t22,c22] = ode15s(@dabra,tspan,c0,options,p);
    t2=[t2(1:end-1)  ; t22];
    c2=[c2(1:end-1,:); c22];
    tspan=[((i-1)*12+p.tlag),(i*12)];
    c0=[c2(end,1)  c2(end,2) c2(end,3) c2(end,4) c2(end,5)  c2(end,6) c2(end,7) c2(end,8) c2(end,9) c2(end,10) c2(end,11) c2(end,12) c2(end,13) c2(end,14) c2(end,15) c2(end,16) c2(end,17) c2(end,18) c2(end,19) c2(end,20) c2(end,21) c2(end,22) c2(end,23) c2(end,24) c2(end,25)];
    [t23,c23] = ode15s(@dabra,tspan,c0,options,p);
    t2=[t2(1:end-1)  ; t23];
    c2=[c2(1:end-1,:); c23];
end
end