function Supplementary_Code_5    
% Title: Dabrafenib PK
% Author: Marco Albrecht
% Last change: 27.07.2018

%% clean
clear global; close all; clc; 
format shortG
%% Parameterdefinition 
%     S.VcFS   S.VpFS   S.QFS  S.kD   S.k1b  S.k1r  S.k1f   S.k1v  S.k1km S.k2b  S.k2r   S.k2f   S.k3b  S.k3r  S.k3v   S.k3km S.k4b  S.k4r  S.k4f  S.k4v  S.k4km S.k6b  S.k6r   S.FU        S.KaK      S.VcK      S.k5b   S.k5r   S.k5f     S.EC     S.ET   S.Vmax S.Km   S.kdeg
%x= [  45.646  0.4*252.14  0.97386  7.7034 16.954 8.2132 1.5877 0.26911 46.981 34.195 3.6069 0.43599 1.2852 35.451 0.071572 6.3887 3.9648 7.4209 1.0915 1.6128 16.775 7.9456 5.514 0.018415 1.6429 49.074 57.796 26.259 2.2939 0.40232      0.16365       8.7421       4.4607       5.5365];
x= [  40.521 126.01 0.91233 6.0044 14.937 9.7891 1.7782 0.2197 51.867 41.443 3.1321 0.48768 0.98899 44.063 0.088238 7.973 4.7801 9.2175 1.2597 1.8307 16.627 6.1655 5.1019 0.020051 1.5576 45.337 49.277 23.484 2.6343 0.47783 0.1603  7.9747 5.2948 6.2687];

% ["p.VcFS",  "p.VpFS", "p.QFS",   "p.kD",    "p.k1b",   "p.k1r",  "p.k1f",  "p.k1v", "p.k1km", "p.k2b",   "p.k2r",  "p.k2f",    "p.k3v",  "p.k3km", "p.k4b", "p.k4r", "p.k4f", "p.k4v",  "p.k4km", "p.k6b", "p.k6r", "p.FU",  "p.KaK", "p.VcK", "p.k5b", "p.k5r", "p.k5f", "p.ET", "p.kt",  "p.kdegRNA"];
x=[ 39.009    217.61     1.0556    3.9348     8.5102     11.614     2.3061   0.12223  125.35    41.546     10.473    0.51236     0.15038   16.007     2.1893  19.527   2.3573    1.1622   8.2074    6.0051   2.1033   0.018424 2.1081   52.764   25.406   4.4343   0.85347  0.60793  0.69877  10.292   ];

ParameterName=["p.VcFS",  "p.VpFS", "p.QFS",   "p.kD",    "p.k1b",   "p.k1r",  "p.k1f",  "p.k2b",   "p.k2r",  "p.k2f",    "p.k3v",    "p.k3km",   "p.k4b",   "p.k4r",   "p.k4f",   "p.k4v",    "p.k4km",  "p.k6b",   "p.k6r",  "p.FU",      "p.KaK",     "p.VcK",     "p.k5b",     "p.k5r",    "p.k5f",     "p.ET",     "p.kt",     "p.kdegRNA"];
x=            [ 39.009     217.61   1.0556     3.9348     8.5102     11.614    2.3061    41.546    10.473    0.51236     0.15038      16.007     2.1893     19.527       2.3573    1.1622      8.2074     6.0051    2.1033   0.018424       2.1081       52.764       25.406       4.4343      0.85347      0.60793    0.69877       10.292   ];
x=            [40.096     240.2     0.97531    4.5544    8.6349      13.457    2.7168   39.389     11.129   0.62106      0.14337      17.283     2.1562      20.155      2.2635    1.183       8.8695    5.7551     1.7941   0.018096       1.8301        51.05       23.982      5.0519      1.0268        0.64989      0.60637       10.107];


%% Just plot but activate plotting=1 in function multiobjective
SensitivityAnalysis(x);

end     
function SensitivityAnalysis(x)
%% Paramete
vars= {'VcFS'   'VpFS'   'QFS'  'kD'   'k1b'  'k1r'  'k1f'  'k2b'  'k2r'   'k2f'  'k3v'   'k3km' 'k4b'  'k4r'  'k4f' 'k4v'  'k4km' 'k6b'  'k6r'   'FU' 'KaK' 'VcK'      'k5b'   'k5r'   'k5f'  'ET' "kt" 'kdegRNA'};
nParamterBins=21; %should be uneven
Range=2 ;% How much percent of the original dynamic, the pertubated sgnal shall change


p.KetoconazoleOn     = 1;
%
%% Always fixed parameter
p.tlag   =   0.482      ;% [h]   absorption lag-time Dabrafenib
p.Fgel   =   0.555     ;% [-]   relative bioavailability of gelatin capsule to HPMC capsule
p.Ka     =   1.88      ;% [L/h] absorption rate constant
p.CL0F   =  17.0       ;% [L/h] apparent initial clearence
p.CLindSS=  17.3       ;% [L/h] apparent inducible clearence at steady state
p.Dref   = 170.0       ;% [mg]  reference dose
p.y      =   0.927     ;% [-]   power of dependence of CLindSS on absorbed dose (LDOS X Fgel)
p.T50    =  67.3       ;% [h]   half-live of clearence induction
p.tlag   =   0.482     ;% [h]   absorption lag-time
p.VcF    =  70.3       ;% [L]   apparent volume of central compartment
p.VpF    = 174.0       ;% [L]   apparent volume of peripheral compartment
p.QF     =   3.3       ;% [L/h] apparent inter-compartmental clearence
p.EC     =   1;

%% Dabrafenib metabolites
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Regimen conditions %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
p.D             = 95      ;%[mg] Dabrafenib dose 
p.Dsolution     =  1      ;%     Dabrafenib given as solution (1) or HPMC (0)    
p.period        =  0      ;%     Periodic (1) or single (0) regimen         
p.DK            =  0      ;%[mg] Ketoconazole dose
p.DKt           =  0      ;%[h]  Ketoconazole dose. Time point of administration
%% Compare to data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 1. Paper: Metabolism and Disposition of Oral Dabrafenib in Cancer Patients: 
%           Proposed Participation of Aryl Nitrogen in Carbon-Carbon Bond 
%           Cleavage via Decarboxylation following Enzymatic Oxidation
%% Dabrafenib
tmeasure{1}= [0.20       1.20     2.00   3.20    6.00    6.80  10.00    13.60  23.60 35.60  48.40];
Cmeasure{1}=[ 1273.99 1775.66  1501.57 851.16  282.13  180.60  130.83   62.47   9.44  3.56   1.80 ];
%% Hydroxy-Dabrafenib 
tmeasure{2}= [  0.40   3.60   6.80   8.00  10.00  12.00 24.40 36.00 48.40];
Cmeasure{2}=[137.54 580.73 422.40 270.42 180.65 135.23 19.86  5.21  3.56];
%% Carbo-Dabrafenib 
tmeasure{3}= [0.40  0.80   1.20   7.20    9.20   12.40   17.20  23.60  36.80  48.40  72.00 96.40 120.40 170.00 172.40 192.40]; %
Cmeasure{3}=[1.39 24.51 169.10 967.20 1396.31 1099.18 1009.89 633.35 416.62 249.28 102.36 51.99  29.99  17.68  13.83   6.40]; %
%% Desmethyl-dabrafenib
tmeasure{4}= [1.20 2.40 3.20 4.00  6.00  7.60 10.00 12.00 24.00 36.40 48.40 72.00 96.40 139.60 164.40 168.40]; %
Cmeasure{4}=[0.30 1.39 2.53 5.43 10.26 15.25 23.01 29.08 36.77 22.13 16.09  8.35  6.35   5.48   2.73   1.38]; %
%% Urine facies
tmeasure{5}= [2.65 9.12 15.00 26.18 50.59 74.12 97.65 121.76 145.29 168.82 192.65 216.18 240.29]; %
Cmeasure{5}= [0.00 1.43 6.08  38.64 67.44 78.71 85.51  90.88  91.95  92.84  93.56  93.92  93.56]; %
%% Function
titleFig='Dabrafenib_metabolism';
HeadStr{1}='Dabrafenib';
HeadStr{2}={'Hydroxy-';'Dabrafenib'};
HeadStr{3}={'Carbo-';'Dabrafenib'};
HeadStr{4}={'Desmethyl-';'Dabrafenib'};
HeadStr{5}='Excretion';
MolN=[7 12 13 14 16];
DK=[0 0 0 0 0];
mode=0 ;% RSS: 0; HeatMap: 1
PlotSensitivityMap(p,x,vars,MolN,nParamterBins,Range,titleFig,HeadStr,tmeasure,Cmeasure,mode,DK)
close all
mode=1 ;% RSS: 0; HeatMap: 1
PlotSensitivityMap(p,x,vars,MolN,nParamterBins,Range,titleFig,HeadStr,tmeasure,Cmeasure,mode,DK)
close all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%% Ketocolazole 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Regimen conditions %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
p.D             =  0      ;%[mg] Dabrafenib dose 
p.Dsolution     =  0      ;%     Dabrafenib given as solution (1) or HPMC (0)    
p.period        =  0      ;%     Periodic (1) or single (0) regimen         
%p.DK            = 100     ;%[mg] Ketoconazole dose
p.DKt           = 100*24  ;%[h]  Ketoconazole dose. Time point of administration
%% Compare to data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2. Paper: Ketoconazole: A Review of its Therapeutic Efficacy in 
%           Superficial and Systemic Fungal Infections (1982)
%% Ketoconazole 100 mg tablet (fastened patients)
tmeasure{1} = [0 0.5 1 1.5 2 3 4 6 8 10 24 32 ] ;
Cmeasure{1} = [0 0.664184892	1.18714261	1.0208095	0.788383335	0.546542185	0.312204129	0.101870573	0.03545488	0.020681366	0.002387942	0.001005899]*1000 ;% [mg/mL]
%% Ketoconazole 200 mg tablet (fastened patients)
tmeasure{2} = [0 0.5 1 1.5 2 3 4 6 8 10 24 48 ] ;
Cmeasure{2} = [0 1.906453063 3.060210777 2.80692053	2.312067004	1.535447452	1.185411919	0.594856632	0.202616181	0.097383691	0.024931012	0.003259119]*1000 ;
%% Ketoconazole 400 mg tablet (fastened patients)
tmeasure{3} = [0 0.5 1 1.5 2 3 4 6 8 10 24  32 48 ] ;
Cmeasure{3} = [0 2.4156184	5.020202311	5.834214706	4.909966872	3.95770851	2.685248004	1.635379393	0.856747509	0.478701454	0.088742895	0.046351214	0.016369086]*1000 ; 
%% Function
titleFig='Ketoconazole';
HeadStr{1}={'Ketoconazole';'100 mg tablet'};
HeadStr{2}={'Ketoconazole';'200 mg tablet'};
HeadStr{3}={'Ketoconazole';'400 mg tablet'};
MolN=[4 4 4];
DK=[100 200 400];
mode=0 ;% RSS: 0; HeatMap: 1
PlotSensitivityMap(p,x,vars,MolN,nParamterBins,Range,titleFig,HeadStr,tmeasure,Cmeasure,mode,DK)
close all
mode=1 ;% RSS: 0; HeatMap: 1
PlotSensitivityMap(p,x,vars,MolN,nParamterBins,Range,titleFig,HeadStr,tmeasure,Cmeasure,mode,DK)
close all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





%% Dabrafenib and Ketocolacole combined
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Regimen conditions %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
p.D             = 75      ;%[mg] Dabrafenib dose 
p.Dsolution     =  0      ;%     Dabrafenib given as solution (1) or HPMC (0)    
p.period        =  1      ;%     Periodic (1) or single (0) regimen         
%p.DK            = 400     ;%[mg] Ketoconazole dose
p.DKt           = 19*24   ;%[h]  Ketoconazole dose. Time point of administration
%p.tmax          = 22.5*24 ;%[h]  Simulation time
%% Compare to data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 3. Paper: Assessment of the drug interaction potential and single? and
%           repeat?dose pharmacokinetics of the BRAF inhibitor dabrafenib (2014)
% Patients received dabrafenib 75 mg twice daily from day 2 to day 17
% Ketoconazole dosed at 400mg daily on Days 19 through 22
% clinicaltrials.gov/ct2/show/NCT01340846?term=GSK2118436&rank=16&submit_fld_opt
% (Link opened 13.04.2018)
%% Dabrafenib only at day 18                                                        
tmeasure{1}  = [  0      0.5    1      1.5    2       3      4      6     8     10      12   ]+17*24; 
Cmeasure{1}  = [123.63 329.78 879.18 842.73 737.66  541.24 367.72 135.07 62.61   5.07   41.21];
%% Dabrafenib and Ketoconazole; Dabrafenib profile at day 22                                            
tmeasure{2} = [  0      0.5    1      1.5     2       3      4      6      8     10    12   ]+21*24; 
Cmeasure{2} = [ 77.87 219.92 599.98 925.13 1177.04  998.94 761.33 327.31 181.63 100.00 68.72];
%% Dabrafenib and Ketoconazole; Ketoconazole profile at day 22  (Supplemental table S-3)                                            
tmeasure{3} = [  0             1              2              4             8           12   ]+21*24;
Cmeasure{3} = [ 69.6        4172.00        5123.40        3026.80        372.3         85.1 ];
%% Function
titleFig='DDI';
HeadStr{1}={'Dabrafenib';'alone day 18'};
HeadStr{2}={'Dabrafenib';'combi day 22'};
HeadStr{3}={'Ketoconazole';'combi day 22'};
MolN=[7 7 4];
DK=[400 400 400];
mode=0 ;% RSS: 0; HeatMap: 1
PlotSensitivityMap(p,x,vars,MolN,nParamterBins,Range,titleFig,HeadStr,tmeasure,Cmeasure,mode,DK)
close all
mode=1 ;% RSS: 0; HeatMap: 1
PlotSensitivityMap(p,x,vars,MolN,nParamterBins,Range,titleFig,HeadStr,tmeasure,Cmeasure,mode,DK)
close all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% %if p.EnzymeRegulationOn ==1
% %% Enzyme regulation
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %% Regimen conditions all %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% p.D             =  NaN    ;%[mg] Dabrafenib dose 
% p.Dsolution     =  0      ;%     Dabrafenib given as solution (1) or HPMC (0)    
% p.period        =  1      ;%     Periodic (1) or single (0) regimen         
% p.DK            =  0      ;%[mg] Ketoconazole dose
% p.DKt           =  0      ;%[h]  Ketoconazole dose. Time point of administration
% p.tmax          = 22*24   ;%[h]  Simulation time
% ts              = p.tlag:0.5:(22+ p.tlag);
% %% Compare to data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % 4. Paper: Population pharmacokinetics of dabrafenib, a BRAF inhibitor: 
% %           effect of dose, time, covariates, and relationship 
% %           with its metabolites (2014)
% %% Dabrafenib 150 mg: Simulation and data fit  %%%%%%%%%%%%%%%%%%%%%%%%%%%%
% p.D             = 150      ;%[mg] Dabrafenib dose update 
% [t15,ce15]=period(p)       ;%Numeric solver of the resulting time course
% d150=[0 93.5	81.4	77.1	72.9	69.8	66.5	63.6	60.7	58.2	55.7	53.5	52	50	48.9	47.5	46.6	45.2	44.8	43.7	43.1	42.3	41.9	41.4	41.2	40.6	40.4	40.2	39.8	39.2	38.8	38.6	38.6	38.1	38.3	38.1	38.1	38.1	38.1	38.1	37.9 repmat(38,1,20)];
% d150=d150(1:(22*2+1))      ;% Shorting data after extension (better balance during the fit)
% [pks15,locs15] = findpeaks(-ce15(:,7),t15);
% %% Dabrafenib 100 mg: Simulation and data fit  %%%%%%%%%%%%%%%%%%%%%%%%%%%%
% if p.EnzymeRegulOnly ==1
% p.D             = 100      ;%[mg] Dabrafenib dose update 
% [t10,ce10]=period(p)       ;%Numeric solver of the resulting time course
% d100=[0 65.3	62.8	62	61.3	59.7	58.2	57	55.5	54.1	52.4	51.6	49.7	48.7	47.7	46.6	45.4	45	44.3	43.9	43.1	42.7	42.7	42.3	41.9	41.4	41	41	40.6	40.6	39.8	40	40.4	39.8	40	39.6	39.6	39.6	39.4	39.4	39 repmat(39,1,20)]; %
% d100=d100(1:(22*2+1));
% [pks10,locs10] = findpeaks(-ce10(:,7),t10);
% %% Dabrafenib  75 mg: Simulation and data fit  %%%%%%%%%%%%%%%%%%%%%%%%%%%%
% p.D             =  75      ;%[mg] Dabrafenib dose update 
% [t75,ce75]=period(p)       ;%Numeric solver of the resulting time course
% d75=[0 50.4	50.8	51.8	52.2	52	51.6	50.4	49.7	48.7	47.9	47	46.2	45.2	44.4	43.5	42.9	42.7	41.9	41.9	41.4	41	40.4	40.4	39.8	40	39	39.6	38.8	38.6	38.8	38.6	38.8	38.6	38.5	38.1	38.1	38.3	38.1	37.9	38.1 repmat(38,1,20)];%
% d75=d75(1:(22*2+1));
% [pks75,locs75] = findpeaks(-ce75(:,7),t75);
% end
% %% Dabrafenib  50 mg: Simulation and data fit  %%%%%%%%%%%%%%%%%%%%%%%%%%%%
% p.D             =  50      ;%[mg] Dabrafenib dose update 
% [t50,ce50]=period(p)       ;%Numeric solver of the resulting time course
% d50=[0  34.6	36.7	38.5	39.2	39.6	39.8	39.8	39.6	39.4	39	38.6	38.5	38.1	37.3	37.1	36.5	36.5	35.7	35.7	35.7	35.6	35.2	34.4	34.6	34.6	34.2	34.2	33.8	33.8	33.8 33.6	33.8	33.6	33.6	33.4	33.6	33.6	33.6	33.2	33.6 repmat(33.5,1,20)]; %
% d50=d50(1:(22*2+1));
% [pks50,locs50] = findpeaks(-ce50(:,7),t50);
% %% 
% try
% if p.EnzymeRegulOnly ==0
%  % Residuals to align data
% ER=sum([ sum((d150(2:length(d150))'+ pks15*1000).^2)  sum((d50(2:length(d50))'+ pks50*1000).^2)]);
% % Standard deviation to align trough concentration shape
% %ERSt=mean([ std(d150(2:length(d150))'+ pks15*1000)  std(d50(2:length(d50))'+ pks50*1000) ]);
% elseif p.EnzymeRegulOnly ==1
% % Residuals to align data
% ER=sum([ sum((d150(2:length(d150))'+ pks15*1000).^2) ;  sum((d100(2:length(d100))'+ pks10*1000).^2) ;  sum((d75(2:length(d75))'+ pks75*1000).^2) ;  sum((d50(2:length(d50))'+ pks50*1000).^2)]);
% % Standard deviation to align trough concentration shape
% %ERSt=mean([ std(d150(2:length(d150))'+ pks15*1000)  std(d100(2:length(d100))'+ pks10*1000)   std(d75(2:length(d75))'+ pks75*1000)   std(d50(2:length(d50))'+ pks50*1000) ]);
% end
% catch
% ER=1000000000;
% %ERSt=10000;
% end
% %% Plotting
% if plotting==1
% figure(3)
% set(gcf,'color','w', 'Units', 'Normalized', 'OuterPosition', [0.5, 0.5, 0.4, 0.4]);
% subplot(2,2,1)
% plot(locs15/24, -pks15*1000,'k',ts,d150,'ko','Linewidth',2);
% title('150 mg Dabrafenib trough')
% ylim([0 1.5*max(d150)])
% if p.EnzymeRegulOnly ==1
% subplot(2,2,2)
% plot(locs10/24,-pks10*1000,'blue',ts,d100,'blue<','Linewidth',2);
% title('100 mg Dabrafenib trough')
% subplot(2,2,3)
% plot(locs75/24,-pks75*1000,'red',ts,d75,'red+','Linewidth',2);
% title('75 mg Dabrafenib trough')
% end
% subplot(2,2,4)
% plot(locs50/24,-pks50*1000,'y',ts,d50,'y>','Linewidth',2);
% title('50 mg Dabrafenib trough')
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% figure(4)
% set(gcf,'color','w', 'Units', 'Normalized', 'OuterPosition', [0.1, 0.1, 0.4, 0.4]);
% subplot(2,2,1)
% plot(t50, ce50(:,2))  
% hold on
% plot(t15, ce15(:,2))
% if p.EnzymeRegulationOn ==1
% plot(t15, repmat(S.ET,length(t15),1))
% end
% hold off
% xlim([0 48])
% %ylim([0.5 1.5])
% title('baseline use')
% subplot(2,2,2)
% plot(t50, ce50(:,22)*1000)
% hold on
% plot(t15, ce15(:,22)*1000)
% hold off
% title('transkription')
% xlim([0 100])
% subplot(2,2,3)
% plot(t50, ce50(:,23)*1000)
% hold on
% plot(t15, ce15(:,23)*1000)
% hold off
% xlim([0 150])
% title('translation')
% subplot(2,2,4)
% plot(t50, ce50(:,25)*1000)
% hold on
% plot(t15, ce15(:,25)*1000)
% hold off
% xlim([0 150])
% title('feedback')
% figure(5)
% d1=subplot(2,2,1);
% Y = ce50(:,[2 8 9 10 11 1])*100;  
% area(d1,t50,Y)
% xlim(d1,[0 48])
% ylim(d1,[0 sum(max(ce50(:,[2 8 9 10 11 1])))*100])
% ylabel(d1,'Relative [%]')
% xticks(d1,[6 12 18 24 30 36 42 48])
% xlabel(d1,'Time [h]')
% title(d1,'CYP3A-Enzyme occupation 50 mg Dabra')
% legend(d1,'E_B','E_{D0}','E_{DH}','E_{DC}','E_{DD}','E_{f}','Location', 'Westoutside')
% legend boxoff   
% clearvars Y
% d2=subplot(2,2,2);
% Y = ce15(:,[2 8 9 10 11 1])*100;  
% area(d2,t15,Y)
% xlim(d2,[0 48])
% ylim(d2,[0 sum(max(ce15(:,[2 8 9 10 11 1])))*100])
% ylabel(d2,'Relative [%]')
% xticks(d2,[6 12 18 24 30 36 42 48])
% xlabel(d2,'Time [h]')
% title(d2,'CYP3A-Enzyme occupation 150 mg Dabra')
% legend(d2,'E_B','E_{D0}','E_{DH}','E_{DC}','E_{DD}','E_{f}','Location', 'Westoutside')
% legend boxoff   
% clearvars Y
% end
% 
% %% Define objective function %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% objective(7) = ER/14309 ;
% %3*sum([ER  ERSt]./[8814.4       3.8176]/2)  ;%Dabrafenib trough concentrations profiles
% %% End of block
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %end
% %objective(7) = 0;
% 
% %% roboust run
% catch
% objective=objectiveFail;  %search "try". Filter rare parameter combinations with infeasible outcome
% end
% %% Single scalar as output if not multiobjective optimization.
% if multiobjectiveOpt == 0
% objective = sum(objective)/5.7 ;%Always normalize to relate objectives better and if normalized to 1, one sees how much the fit improves or not improves
% end
% %objective
% %profile viewer




end
function PlotSensitivityMap(p,x,vars,MolN,nParamterBins,Range,titleFig,HeadStr,tmeasure,Cmeasure, mode, DK)
if mode==0
ModeName='RSS';  
WidthAdjust=1;% Adjust figure width to avoid overlap on y-axis label
end
if mode==1
ModeName='HeatMap';
WidthAdjust=1.5;%Adjust figure width to avoid overlap on y-axis label
%% Color map:Blue to light cyan to white to red    
n = 40;               %// number of color stages
R = [linspace(70 ,224,n) linspace(224,255,5) linspace(255,255,5)   linspace(255,200,n)];  %// Red from 1 to 0
G = [linspace(130,255,n) linspace(255,255,5) linspace(255,222,5)   linspace(222,0,n)];
B = [linspace(180,255,n) linspace(255,255,5) linspace(255,173,5)   linspace(173,0,n)];   %// Blue from 0 to 1
MapCostum=colormap( [R(:), G(:), B(:)]/255 );  %// create colormap
end
%% Parameter
MaxRowPage=5;
Counter=MaxRowPage;
NumberMolek=length(MolN);
S = [];
%% First Figure
h = figure(1);
x0=50;
y0=10;
width=21*25*WidthAdjust;
height=29.7*25;
set(gcf,'units','points','position',[x0,y0,width,height])
set(gcf,'color','w')
set(gca,'FontSize',1)
for k =1:length(MolN)
subplot(MaxRowPage,NumberMolek+1,k+1,'visible','off')
text('units','pixels','position',[0 50],'FontSize',12,'string',HeadStr{k},'Interpreter','latex');
end

for i=1:length(x)
    %% prepare figue
    if Counter==0
        h = figure(ceil(i/MaxRowPage));
        x0=50;
        y0=10;
        width=21*25*WidthAdjust;
        height=29.7*25;
        set(gcf,'units','points','position',[x0,y0,width,height])
        set(gcf,'color','w')
        set(gca,'FontSize',1)
        % Head title
        for k =1:length(MolN)
        subplot(MaxRowPage+1,NumberMolek+1,k+1,'visible','off')
        text('units','pixels','position',[0 0],'FontSize',12,'string',HeadStr{k},'Interpreter','latex');
        end
        %
        Counter = MaxRowPage-1;
    else
        Counter = Counter   -1;
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %% Range of parameter subjected to sensitivity analysis
    Pname=vars(i); %Save the name
    % Define the parameter range
    Pspace=[linspace(0.1*x(i),x(i),nParamterBins) linspace(x(i),10*x(i),nParamterBins)];
    Pspace=unique(Pspace);
    %% Go for all suggested timecourses MolN
    for k =1:length(MolN)
         %% Fit reference time course
            % load orignal parameter set
            for d=1:length(vars)
            S.(vars{d}) = x(d);   
            end
            p.tmax  = 1.1*max(tmeasure{k})  ;%[h]  Simulation time
            p.DK    = DK(k);
           [tO,CsO]=period(p,S);
            % Heatmap
            if mode==1
            MatrixP  =zeros(length(tO),nParamterBins);
            end
            % RSS reference
            if mode==0
            CsR1 =interp1(tO,1000*CsO(:,MolN(k)),tmeasure{k});
            RSSraw1=(CsR1 - Cmeasure{k}).^2;
            RSSref=nanmean(RSSraw1);   
            RSS   =zeros(1,length(Pspace));
            end
        %% find distance to original fit over parameter range
        for m=1:length(Pspace)
            S.(vars{i}) = Pspace(m);
            [t,c]=period(p,S);%Numeric solver
            % heat map
            if mode==1
            CsH =interp1(t, c(:,MolN(k)),tO);
            MatrixP(:,m)=CsH-CsO(:,MolN(k));
            end
            % RSS
            if mode==0
            CsR2 =interp1(t ,1000*c(:,MolN(k)),tmeasure{k}); 
            RSSraw2=(CsR2 - Cmeasure{k}).^2;
            RSS(m)=nanmean(RSSraw2)/RSSref;
            end
        end
        %% Make subfigure
        Reduc=floor((i-1)/(MaxRowPage)); % reduce by the number of slots per page with each page 
        subplot(MaxRowPage+1,NumberMolek+1,(k+1+(NumberMolek+1)*(i))-Reduc*(MaxRowPage*(NumberMolek+1)))
        if mode==1
        MatrixP=MatrixP/(max(CsO(:,MolN(k)))-min(CsO(:,MolN(k)))); %normalised to measurement range
        %% Refine Grid with linear interpolation (better resolution)
        [X,Y] = meshgrid(1:size(MatrixP,2), 1:size(MatrixP,1));
        [X2,Y2] = meshgrid(1:0.2:size(MatrixP,2), 1:0.5:size(MatrixP,1));
        MatrixFine = interp2(X, Y, MatrixP, X2, Y2, 'linear');
        %% Plot heatmap
        h1=heatmap(MatrixFine,'Colormap',MapCostum,'ColorLimits',[-Range Range],'GridVisible','off','ColorbarVisible','off');%
        h1.YDisplayLabels=char(num2str(round(min(tO))), repmat(' ',size(MatrixFine,1)-2,1), num2str(round(max(tO))));
        h1.XDisplayLabels=char(num2str(round(min(Pspace),2,'significant')), repmat(' ',ceil(0.5*size(MatrixFine,2)-2),1),num2str(round(x(i),2,'significant')), repmat(' ',floor(0.5*size(MatrixFine,2)-1),1), num2str(round(max(Pspace),2,'significant')));  
        end
        if mode==0
        plot(Pspace,RSS,'LineWidth',2);
        box off
        line([x(i),x(i)],[0,1])
        ylim([0 2])
        xlim([min(Pspace),max(Pspace)])
        end
    end
    %% Row title
    subplot(MaxRowPage+1,NumberMolek+1,1+(NumberMolek+1)*i-Reduc*((MaxRowPage)*(NumberMolek+1)),'visible','off')
    text('units','pixels','position',[40 50],'FontSize',12,'string',Pname,'Interpreter','latex');
    %% Save plot
    if Counter==0 % save if page is full
        pos = get(h,'Position');
        set(h,'PaperPositionMode','Auto','PaperUnits','points','PaperSize',[pos(3), pos(4)]);
        export_fig(strcat(titleFig,'_',ModeName,'_',num2str(Reduc+1),'.pdf'),'-pdf');
    end
end
%% Save the last figure when not full
pos = get(h,'Position');
set(h,'PaperPositionMode','Auto','PaperUnits','points','PaperSize',[pos(3), pos(4)]);
export_fig(strcat(titleFig,'_',ModeName,'_',num2str(Reduc+1),'.pdf'),'-pdf');
end
function [t2,c2]=period(p,S)
options = odeset('RelTol',1e-3,'AbsTol',1e-2);
warning('off','all')
% if Ketoconacole joins later to regimen
if   p.period==1
    for i = 1:floor((p.tmax+p.tlag)/12+1)
        %% 0 to p.tlag
        tspan=[((i-1)*12),((i-1)*12+p.tlag)];
        if i==1 %First dose
            c0=zeros(1,23);
            c0( 1)= (S.k6r/S.k6b*p.EC)/(1 + S.k6r/S.k6b); %analytic steady state solution w
%             p.E0=c0( 1);
            c0( 2)= p.EC-c0( 1);
%             if p.EnzymeRegulationOn == 1
%                 p.K = (p.kRNAdeg*p.Edeg2*p.Edeg1/p.kt)*(p.E0  +  (p.FB*p.Edeg1*p.E0^2)/( p.kt*p.Edeg2^2) ); %baseline production;
%             end
            %Solution makes oral compartment necessary
            if p.Dsolution==1
                c0(6) = p.D;
            end
            % once daily Ketoconacole after first application at dKt. if 'i' is odd, give drug
            if p.DKt <= tspan(1)
                if mod(i,2)==1
                    c0(3) =  p.DK;
                end
            end
            c2=c0;
            t2=0;
        else % following doses
            c0=[c2(end,1)  c2(end,2) c2(end,3) c2(end,4) c2(end,5) c2(end,6) c2(end,7) c2(end,8) c2(end,9) c2(end,10) c2(end,11) c2(end,12) c2(end,13) c2(end,14) c2(end,15) c2(end,16) c2(end,17) c2(end,18) c2(end,19) c2(end,20) c2(end,21) c2(end,22) c2(end,23)  ];
            % Solution makes oral compartment necessary
            if p.Dsolution==1
                c0(6) = c2(end,6) + p.D;
            end
            % once daily Ketoconacole after first application at dKt. if 'i' is odd, give drug
            if p.DKt <= tspan(1)
                if mod(i,2)==1
                    c0(3) = c2(end,3)+ p.DK;
                end
            end
        end
        [t22,c22] = ode15s(@dabra,tspan,c0,options,p,S);
        t2=[t2(1:end-1)  ; t22];
        c2=[c2(1:end-1,:); c22];
        %% p.tlag to 12h
        tspan=[((i-1)*12+p.tlag),( i*12)];
        c0=[c2(end,1)  c2(end,2) c2(end,3) c2(end,4) c2(end,5) c2(end,6) c2(end,7) c2(end,8) c2(end,9) c2(end,10) c2(end,11) c2(end,12) c2(end,13) c2(end,14) c2(end,15) c2(end,16) c2(end,17) c2(end,18) c2(end,19) c2(end,20) c2(end,21) c2(end,22) c2(end,23)];
        [t22,c22] = ode15s(@dabra,tspan,c0,options,p,S);
        t2=[t2(1:end-1)  ; t22];
        c2=[c2(1:end-1,:); c22];
    end
else
    %% 0 to p.tlag
    tspan=[0 ,   p.tlag];
    c0=zeros(1,23);
    c0( 1)= (S.k6r/S.k6b*p.EC)/(1 + S.k6r/S.k6b); %analytic steady state solution with
    c0( 2)= p.EC-c0( 1);
%     if p.EnzymeRegulationOn == 1
%         p.K = (p.kRNAdeg*p.Edeg2*p.Edeg1/p.kt)*(p.E0  +  (p.FB*p.Edeg1*p.E0^2)/( p.kt*p.Edeg2^2) ); %baseline productionp
%     end
    c0(3)=p.DK;
    if p.Dsolution==1
        c0(6)=p.D;
    end
    c2=c0;
    t2=0;
    [t22,c22]   = ode15s(@dabra,tspan,c0,options,p,S);
    t2=[t2(1:end-1)  ; t22];
    c2=[c2(1:end-1,:); c22];
    %% p.tlag to 12h
    tspan=[p.tlag ,p.tmax];
    c0=[c2(end,1)  c2(end,2) c2(end,3) c2(end,4) c2(end,5) c2(end,6) c2(end,7) c2(end,8) c2(end,9) c2(end,10) c2(end,11) c2(end,12) c2(end,13) c2(end,14) c2(end,15) c2(end,16) c2(end,17) c2(end,18) c2(end,19) c2(end,20) c2(end,21) c2(end,22) c2(end,23)  ];
    [t22,c22]   = ode15s(@dabra,tspan,c0,options,p,S);
    t2=[t2(1:end-1)  ; t22];
    c2=[c2(1:end-1,:); c22];
end
end
function dcdt=dabra(t,c,p,S)
%% Fixed Dabrafenib parameters
if p.Dsolution==1
    p.VcF    =   S.VcFS    ;% [L]   apparent volume of central compartment.
    p.VpF    =   S.VpFS    ;% [L]   apparent volume of peripheral compartment.
    p.QF     =   S.QFS     ;% [L/h] apparent inter-compartmental clearence.
else
    if           t < p.tlag
        Term   = 0;
    else
        if p.period ==1
            Term   = 0;
            nmax = floor(min([4*7*24 p.tmax])/12);%maximal num of cycles. Never more than 4*7*24
            n = min([floor((t-p.tlag)/12) nmax]);
            for  i = 1:(n+1)
                Term = Term + exp( -p.Ka*(t-(i-1)*12-p.tlag));
            end
        else
            Term = exp( -p.Ka *(t-p.tlag));
        end
    end
end
ClFind =  p.CLindSS*(p.D*p.Fgel/p.Dref)^p.y *(1-exp(-log(2)*t/p.T50));  % inducible clearence
ClF    =  p.CL0F + ClFind; % plus oral clearence

%% Reaction terms
% Michaelis Menten
CYP2C8  = 0; %S.k1v*c(07)/(S.k1km+c(07))                         ;% If product inhibition(p.k1v*c( 7)/p.k1km)/(1+(c( 7)/p.k1km)+(c( 7)/p.k1Im)) 
PHmm    = S.k3v*c(13)/(S.k3km+c(13))                             ;% DC->DD Lysosom/H30+ dependend
CYP2C19 = S.k4v*c(14)/(S.k4km+c(14))                             ;
% Enzyme occupation with dabrafenib metabolit
D0use   = S.k1b*c(1)*c( 7) - S.k1r*c( 8) - S.k1f*c( 8) ;   
DHuse   = S.k2b*c(1)*c(12) - S.k2r*c( 9) - S.k2f*c( 9) ;
%DCuse   = p.k3b*c(1)*c(13) - p.k3r*c(10)               ; %product inhibition sensitivity analysis says no 
DDuse   = S.k4b*c(1)*c(14) - S.k4r*c(11) - S.k4f*c(11) ;
Buse    = S.k6b*c(1)       - S.k6r*c(2)                ;
% Ketoconazole available
if p.KetoconazoleOn == 1
Keton   = S.k5b*c(1)*c(4)  - S.k5r*c(5)  - S.k5f*c(5)  ;
else
Keton  = 0;
end
%% CYP3A concentration and Baseline use 
dcdt( 1) =  S.kt*c(22) -D0use -DHuse  -DDuse -Buse - Keton                                                                      ;%  d[E_f]dt    + (-min((c( 2)-p.ket),0))*p.kep -  c( 1)*p.ked            
dcdt( 2) =                                     Buse                                                                                                                             ;%  d[E_B]dt  baseline use of active enzyme   
%% Ketoconazole
if p.KetoconazoleOn == 1
dcdt( 3) =   - S.KaK*c(3)                                                                                                                                                       ;%  d[K_oral]   
dcdt( 4) =     S.KaK*c(3)/S.VcK                                                                                            - S.k5b*c(1)*c(4) + S.k5r*c(5)                       ;%  d[Kc]                                   
dcdt( 5) =                  Keton                                                                                                                                               ;%  d[E_K]dt    
else
dcdt( 3) = 0                                                                                                                                                                    ;%  d[K_oral]   
dcdt( 4) = 0                                                                                                                                                                    ;%  d[K_c]                                   
dcdt( 5) = 0                                                                                                                                                                    ;%  d[E_K]dt       
end
%% Dabrafenib solution radioactive (neclect p.FU because it is faster metabolized than excreted)
if p.Dsolution==1
dcdt( 6) =  - S.kD*c(6)                                                                                                                                                         ;%  d[D_0oral]dt  
dcdt( 7) =    S.kD*c(6)/p.VcF       - p.QF/p.VcF*(c(7)-c(18))  - CYP2C8                                                   - S.k1b*c(1)*c( 7)  + S.k1r*c( 8)                     ;%  d[D_0c]dt             
dcdt( 8) =                  D0use                                                                                                                                               ;%  d[E_D0]dt
%% Dabrafenib pill                  (neclect p.FU because it is faster metabolized than excreted)
else
dcdt( 6) =    p.Ka*p.D*Term/(p.VcF) - p.QF/p.VcF*(c(6)-c(18))  - ClF*c(6)/p.VcF                                                                                                 ;%  d[D_0c-paper]dt
dcdt( 7) =    p.Ka*p.D*Term/(p.VcF) - p.QF/p.VcF*(c(7)-c(18))  - CYP2C8                                                    - S.k1b*c(1)*c( 7)  + S.k1r*c( 8)                    ;%  d[D_0c-model]dt
dcdt( 8) =                  D0use                                                                                                                                               ;%  d[E_D0]dt
end
%% Dabrafenib Metabolites 
dcdt( 9) =                  DHuse                                                                                                                                               ;%  d[E_DH]dt
dcdt(10) =  0;               %DCuse                                                                                                                                             ;%  d[E_DC]dt    
dcdt(11) =                  DDuse                                                                                                                                               ;%  d[E_DD]dt
dcdt(12) = - S.FU*c(12)             - p.QF/p.VcF*(c(12)-c(19)) + CYP2C8                                                   - S.k2b*c(1)*c(12)  + S.k2r*c( 9)  + S.k1f*c( 8)      ;%  d[D_Hc]dt  
dcdt(13) = - S.FU*c(13)             - p.QF/p.VcF*(c(13)-c(20))            - PHmm                                                                             + S.k2f*c( 9)      ;%  d[D_Cc]dt   DC->DD Lysosom/H30+ dependend  - p.k3b*c(1)*c(13)  + p.k3r*c(10)
dcdt(14) = - S.FU*c(14)             - p.QF/p.VcF*(c(14)-c(21)) - CYP2C19  + PHmm                                          - S.k4b*c(1)*c(14)  + S.k4r*c(11)                     ;%  d[D_Dc]dt
dcdt(15) = - S.FU*c(15)                                        + CYP2C19                                                                                     + S.k4f*c(11)      ;%  d[M   ]dt
%% Excretion of dabrafenib
dcdt(16) =   S.FU*(c(12)+c(13)+c(14)+c(15))                                                                                                                                     ;% d[U]d excretion
%% peripheral compartment 
dcdt(17) =                            p.QF/p.VpF*(c( 6)-  c(17)) ;% d[D_0p]dt peripheral compartment of D0_oral or D0_c paper c( 6) 
dcdt(18) =                            p.QF/p.VpF*(c( 7) - c(18)) ;% d[D_0p]dt peripheral compartment of D0 c( 7)
dcdt(19) =                            p.QF/p.VpF*(c(12) - c(19)) ;% d[D_Hp]dt peripheral compartment of DH c(11)
dcdt(20) =                            p.QF/p.VpF*(c(13) - c(20)) ;% d[D_Cp]dt peripheral compartment of DC c(13)
dcdt(21) =                            p.QF/p.VpF*(c(14) - c(21)) ;% d[D_Dp]dt peripheral compartment of DD c(14)   
%% Enzyme regulation 
dcdt(22) =  (-min((c( 2)-S.ET),0))  - S.kdegRNA*c(22)                     ;%  EmRNA      % +p.kp
dcdt(23) =  S.kt*c(22) -c(23)                                             ;%  translation
% dcdt(24) =  0; %p.kt*c(22) -c(23)   -p.kdegE*c(1)  - c(25)                ;%  netto enzyme regulation
% dcdt(25) =  0; %-p.kdegE*c(1) - c(25)                                     ;%  protein degradation  
%%   
dcdt = dcdt';   % important! - transposes the solution vector
end     